#include "stacktool.h"
#include "bdd_bitbit_cpc.h"

struct mem_loc_t bdd_bitbit_cpc_res (struct mem_loc_t in1, struct mem_loc_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2.val, bdd_op_inputs, 2 * 8);
  explode (in2.known, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x3; ++cc_value) {
    if ((cc.val & cc.known & 0x3) != 
	(cc_value & cc.known & 0x3)) continue;
    if ((cc_value & ~0x3) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_0_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 2:
  // bitbit_00_2_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_2_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_2_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_2_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_2_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_2_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_2_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_2_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_2_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_2_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_2_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_2_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_2_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_2_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_2_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_2_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_1_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_1_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_1_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_1_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_1_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_1_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_1_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_1_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_1_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_1_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_1_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_1_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_1_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_1_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_1_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 3:
  // bitbit_00_3_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_3_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_3_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_3_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_3_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_3_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_3_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_3_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_3_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_3_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_3_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_3_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_3_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_3_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_3_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_3_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int cpc_8_cc_0_tmp_0 (void) {
  return (bdd_op_inputs[7]?0:(bdd_op_inputs[15] && bdd_op_inputs[23]));
}

static int cpc_8_cc_0_tmp_1 (void) {
  return (bdd_op_inputs[22] && cpc_8_cc_0_tmp_0 ());
}

static int cpc_8_cc_0_tmp_2 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_0_tmp_1 ():(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpc_8_cc_0_tmp_0 ()):cpc_8_cc_0_tmp_1 ()));
}

static int cpc_8_cc_0_tmp_3 (void) {
  return (bdd_op_inputs[21] && cpc_8_cc_0_tmp_2 ());
}

static int cpc_8_cc_0_tmp_4 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_0_tmp_3 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_0_tmp_2 ()):cpc_8_cc_0_tmp_3 ()));
}

static int cpc_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[20] && cpc_8_cc_0_tmp_4 ());
}

static int cpc_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_0_tmp_5 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_0_tmp_4 ()):cpc_8_cc_0_tmp_5 ()));
}

static int cpc_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[19] && cpc_8_cc_0_tmp_6 ());
}

static int cpc_8_cc_0_tmp_8 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_0_tmp_7 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_0_tmp_6 ()):cpc_8_cc_0_tmp_7 ()));
}

static int cpc_8_cc_0_tmp_9 (void) {
  return (bdd_op_inputs[18] && cpc_8_cc_0_tmp_8 ());
}

static int cpc_8_cc_0_tmp_10 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_0_tmp_9 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_0_tmp_8 ()):cpc_8_cc_0_tmp_9 ()));
}

static int cpc_8_cc_0_tmp_11 (void) {
  return (bdd_op_inputs[17] && cpc_8_cc_0_tmp_10 ());
}

static int cpc_8_cc_0_tmp_12 (void) {
  return (bdd_op_inputs[1]?cpc_8_cc_0_tmp_11 ():(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpc_8_cc_0_tmp_10 ()):cpc_8_cc_0_tmp_11 ()));
}

static int cpc_8_cc_0_tmp_13 (void) {
  return (bdd_op_inputs[24] || cpc_8_cc_0_tmp_12 ());
}

static int cpc_8_cc_0_tmp_14 (void) {
  return (bdd_op_inputs[24] && cpc_8_cc_0_tmp_12 ());
}

static int cpc_8_cc_0_tmp_15 (void) {
  return (bdd_op_inputs[16]?0:cpc_8_cc_0_tmp_14 ());
}

static int cpc_8_cc_0_tmp_16 (void) {
  return bdd_op_inputs[31];
}

static int cpc_8_cc_0_tmp_17 (void) {
  return (bdd_op_inputs[23]?0:cpc_8_cc_0_tmp_16 ());
}

static int cpc_8_cc_0_tmp_18 (void) {
  return (bdd_op_inputs[7] || cpc_8_cc_0_tmp_17 ());
}

static int cpc_8_cc_0_tmp_19 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_0_tmp_18 ());
}

static int cpc_8_cc_0_tmp_20 (void) {
  return (bdd_op_inputs[30] && cpc_8_cc_0_tmp_18 ());
}

static int cpc_8_cc_0_tmp_21 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_0_tmp_18 ():cpc_8_cc_0_tmp_19 ()):(bdd_op_inputs[22]?0:cpc_8_cc_0_tmp_20 ()));
}

static int cpc_8_cc_0_tmp_22 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_0_tmp_21 ());
}

static int cpc_8_cc_0_tmp_23 (void) {
  return (bdd_op_inputs[29] && cpc_8_cc_0_tmp_21 ());
}

static int cpc_8_cc_0_tmp_24 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_0_tmp_21 ():cpc_8_cc_0_tmp_22 ()):(bdd_op_inputs[21]?0:cpc_8_cc_0_tmp_23 ()));
}

static int cpc_8_cc_0_tmp_25 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_0_tmp_24 ());
}

static int cpc_8_cc_0_tmp_26 (void) {
  return (bdd_op_inputs[28] && cpc_8_cc_0_tmp_24 ());
}

static int cpc_8_cc_0_tmp_27 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_0_tmp_24 ():cpc_8_cc_0_tmp_25 ()):(bdd_op_inputs[20]?0:cpc_8_cc_0_tmp_26 ()));
}

static int cpc_8_cc_0_tmp_28 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_0_tmp_27 ());
}

static int cpc_8_cc_0_tmp_29 (void) {
  return (bdd_op_inputs[27] && cpc_8_cc_0_tmp_27 ());
}

static int cpc_8_cc_0_tmp_30 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_0_tmp_27 ():cpc_8_cc_0_tmp_28 ()):(bdd_op_inputs[19]?0:cpc_8_cc_0_tmp_29 ()));
}

static int cpc_8_cc_0_tmp_31 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_0_tmp_30 ());
}

static int cpc_8_cc_0_tmp_32 (void) {
  return (bdd_op_inputs[26] && cpc_8_cc_0_tmp_30 ());
}

static int cpc_8_cc_0_tmp_33 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_0_tmp_30 ():cpc_8_cc_0_tmp_31 ()):(bdd_op_inputs[18]?0:cpc_8_cc_0_tmp_32 ()));
}

static int cpc_8_cc_0_tmp_34 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_0_tmp_33 ());
}

static int cpc_8_cc_0_tmp_35 (void) {
  return (bdd_op_inputs[25] && cpc_8_cc_0_tmp_33 ());
}

static int cpc_8_cc_0_tmp_36 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_0_tmp_33 ():cpc_8_cc_0_tmp_34 ()):(bdd_op_inputs[17]?0:cpc_8_cc_0_tmp_35 ()));
}

static int cpc_8_cc_0_tmp_37 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_0_tmp_12 ():(bdd_op_inputs[24] && cpc_8_cc_0_tmp_36 ()));
}

static int cpc_8_cc_0_tmp_38 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_0_tmp_36 ():cpc_8_cc_0_tmp_14 ());
}

static int cpc_8_cc_0_tmp_39 (void) {
  return (bdd_op_inputs[16] && cpc_8_cc_0_tmp_12 ());
}

static int cpc_8_cc_0_tmp_40 (void) {
  return (bdd_op_inputs[7] || (bdd_op_inputs[15]?cpc_8_cc_0_tmp_16 ():cpc_8_cc_0_tmp_17 ()));
}

static int cpc_8_cc_0_tmp_41 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_0_tmp_40 ():cpc_8_cc_0_tmp_19 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpc_8_cc_0_tmp_40 ():cpc_8_cc_0_tmp_0 ())):(bdd_op_inputs[22]?cpc_8_cc_0_tmp_0 ():cpc_8_cc_0_tmp_20 ())));
}

static int cpc_8_cc_0_tmp_42 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_0_tmp_41 ():cpc_8_cc_0_tmp_22 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_0_tmp_41 ():cpc_8_cc_0_tmp_2 ())):(bdd_op_inputs[21]?cpc_8_cc_0_tmp_2 ():cpc_8_cc_0_tmp_23 ())));
}

static int cpc_8_cc_0_tmp_43 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_0_tmp_42 ():cpc_8_cc_0_tmp_25 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_0_tmp_42 ():cpc_8_cc_0_tmp_4 ())):(bdd_op_inputs[20]?cpc_8_cc_0_tmp_4 ():cpc_8_cc_0_tmp_26 ())));
}

static int cpc_8_cc_0_tmp_44 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_0_tmp_43 ():cpc_8_cc_0_tmp_28 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_0_tmp_43 ():cpc_8_cc_0_tmp_6 ())):(bdd_op_inputs[19]?cpc_8_cc_0_tmp_6 ():cpc_8_cc_0_tmp_29 ())));
}

static int cpc_8_cc_0_tmp_45 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_0_tmp_44 ():cpc_8_cc_0_tmp_31 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_0_tmp_44 ():cpc_8_cc_0_tmp_8 ())):(bdd_op_inputs[18]?cpc_8_cc_0_tmp_8 ():cpc_8_cc_0_tmp_32 ())));
}

static int cpc_8_cc_0_tmp_46 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_0_tmp_45 ():cpc_8_cc_0_tmp_34 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_0_tmp_45 ():cpc_8_cc_0_tmp_10 ())):(bdd_op_inputs[17]?cpc_8_cc_0_tmp_10 ():cpc_8_cc_0_tmp_35 ())));
}

static int cpc_8_cc_0_tmp_47 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_0_tmp_46 ():cpc_8_cc_0_tmp_13 ());
}

static int cpc_8_cc_0_tmp_48 (void) {
  return (bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_0_tmp_46 ():cpc_8_cc_0_tmp_36 ()));
}

static int cpc_8_cc_2_tmp_49 (void) {
  return bdd_op_inputs[23];
}

static int cpc_8_cc_2_tmp_50 (void) {
  return (bdd_op_inputs[15] && cpc_8_cc_2_tmp_49 ());
}

static int cpc_8_cc_2_tmp_51 (void) {
  return (bdd_op_inputs[7]?0:cpc_8_cc_2_tmp_50 ());
}

static int cpc_8_cc_2_tmp_52 (void) {
  return (bdd_op_inputs[22] && cpc_8_cc_2_tmp_51 ());
}

static int cpc_8_cc_2_tmp_53 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_2_tmp_52 ():(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpc_8_cc_2_tmp_51 ()):cpc_8_cc_2_tmp_52 ()));
}

static int cpc_8_cc_2_tmp_54 (void) {
  return (bdd_op_inputs[21] && cpc_8_cc_2_tmp_53 ());
}

static int cpc_8_cc_2_tmp_55 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_2_tmp_54 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_2_tmp_53 ()):cpc_8_cc_2_tmp_54 ()));
}

static int cpc_8_cc_2_tmp_56 (void) {
  return (bdd_op_inputs[20] && cpc_8_cc_2_tmp_55 ());
}

static int cpc_8_cc_2_tmp_57 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_2_tmp_56 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_2_tmp_55 ()):cpc_8_cc_2_tmp_56 ()));
}

static int cpc_8_cc_2_tmp_58 (void) {
  return (bdd_op_inputs[19] && cpc_8_cc_2_tmp_57 ());
}

static int cpc_8_cc_2_tmp_59 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_2_tmp_58 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_2_tmp_57 ()):cpc_8_cc_2_tmp_58 ()));
}

static int cpc_8_cc_2_tmp_60 (void) {
  return (bdd_op_inputs[18] && cpc_8_cc_2_tmp_59 ());
}

static int cpc_8_cc_2_tmp_61 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_2_tmp_60 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_2_tmp_59 ()):cpc_8_cc_2_tmp_60 ()));
}

static int cpc_8_cc_2_tmp_62 (void) {
  return (bdd_op_inputs[17] && cpc_8_cc_2_tmp_61 ());
}

static int cpc_8_cc_2_tmp_63 (void) {
  return (bdd_op_inputs[1]?cpc_8_cc_2_tmp_62 ():(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpc_8_cc_2_tmp_61 ()):cpc_8_cc_2_tmp_62 ()));
}

static int cpc_8_cc_2_tmp_64 (void) {
  return (bdd_op_inputs[24] || cpc_8_cc_2_tmp_63 ());
}

static int cpc_8_cc_2_tmp_65 (void) {
  return (bdd_op_inputs[24] && cpc_8_cc_2_tmp_63 ());
}

static int cpc_8_cc_2_tmp_66 (void) {
  return (bdd_op_inputs[16]?0:cpc_8_cc_2_tmp_65 ());
}

static int cpc_8_cc_2_tmp_16 (void) {
  return bdd_op_inputs[31];
}

static int cpc_8_cc_2_tmp_17 (void) {
  return (bdd_op_inputs[23]?0:cpc_8_cc_2_tmp_16 ());
}

static int cpc_8_cc_2_tmp_67 (void) {
  return (bdd_op_inputs[7] || cpc_8_cc_2_tmp_17 ());
}

static int cpc_8_cc_2_tmp_68 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_2_tmp_67 ());
}

static int cpc_8_cc_2_tmp_69 (void) {
  return (bdd_op_inputs[30] && cpc_8_cc_2_tmp_67 ());
}

static int cpc_8_cc_2_tmp_70 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_2_tmp_67 ():cpc_8_cc_2_tmp_68 ()):(bdd_op_inputs[22]?0:cpc_8_cc_2_tmp_69 ()));
}

static int cpc_8_cc_2_tmp_71 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_2_tmp_70 ());
}

static int cpc_8_cc_2_tmp_72 (void) {
  return (bdd_op_inputs[29] && cpc_8_cc_2_tmp_70 ());
}

static int cpc_8_cc_2_tmp_73 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_2_tmp_70 ():cpc_8_cc_2_tmp_71 ()):(bdd_op_inputs[21]?0:cpc_8_cc_2_tmp_72 ()));
}

static int cpc_8_cc_2_tmp_74 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_2_tmp_73 ());
}

static int cpc_8_cc_2_tmp_75 (void) {
  return (bdd_op_inputs[28] && cpc_8_cc_2_tmp_73 ());
}

static int cpc_8_cc_2_tmp_76 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_2_tmp_73 ():cpc_8_cc_2_tmp_74 ()):(bdd_op_inputs[20]?0:cpc_8_cc_2_tmp_75 ()));
}

static int cpc_8_cc_2_tmp_77 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_2_tmp_76 ());
}

static int cpc_8_cc_2_tmp_78 (void) {
  return (bdd_op_inputs[27] && cpc_8_cc_2_tmp_76 ());
}

static int cpc_8_cc_2_tmp_79 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_2_tmp_76 ():cpc_8_cc_2_tmp_77 ()):(bdd_op_inputs[19]?0:cpc_8_cc_2_tmp_78 ()));
}

static int cpc_8_cc_2_tmp_80 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_2_tmp_79 ());
}

static int cpc_8_cc_2_tmp_81 (void) {
  return (bdd_op_inputs[26] && cpc_8_cc_2_tmp_79 ());
}

static int cpc_8_cc_2_tmp_82 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_2_tmp_79 ():cpc_8_cc_2_tmp_80 ()):(bdd_op_inputs[18]?0:cpc_8_cc_2_tmp_81 ()));
}

static int cpc_8_cc_2_tmp_83 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_2_tmp_82 ());
}

static int cpc_8_cc_2_tmp_84 (void) {
  return (bdd_op_inputs[25] && cpc_8_cc_2_tmp_82 ());
}

static int cpc_8_cc_2_tmp_85 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_2_tmp_82 ():cpc_8_cc_2_tmp_83 ()):(bdd_op_inputs[17]?0:cpc_8_cc_2_tmp_84 ()));
}

static int cpc_8_cc_2_tmp_86 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_2_tmp_63 ():(bdd_op_inputs[24] && cpc_8_cc_2_tmp_85 ()));
}

static int cpc_8_cc_2_tmp_87 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_2_tmp_85 ():cpc_8_cc_2_tmp_65 ());
}

static int cpc_8_cc_2_tmp_88 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_2_tmp_49 ():(bdd_op_inputs[15] && cpc_8_cc_2_tmp_17 ()));
}

static int cpc_8_cc_2_tmp_89 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22] && cpc_8_cc_2_tmp_88 ()):(bdd_op_inputs[14] && (bdd_op_inputs[22]?0:(bdd_op_inputs[30] && cpc_8_cc_2_tmp_88 ()))));
}

static int cpc_8_cc_2_tmp_90 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21] && cpc_8_cc_2_tmp_89 ()):(bdd_op_inputs[13] && (bdd_op_inputs[21]?0:(bdd_op_inputs[29] && cpc_8_cc_2_tmp_89 ()))));
}

static int cpc_8_cc_2_tmp_91 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20] && cpc_8_cc_2_tmp_90 ()):(bdd_op_inputs[12] && (bdd_op_inputs[20]?0:(bdd_op_inputs[28] && cpc_8_cc_2_tmp_90 ()))));
}

static int cpc_8_cc_2_tmp_92 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19] && cpc_8_cc_2_tmp_91 ()):(bdd_op_inputs[11] && (bdd_op_inputs[19]?0:(bdd_op_inputs[27] && cpc_8_cc_2_tmp_91 ()))));
}

static int cpc_8_cc_2_tmp_93 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18] && cpc_8_cc_2_tmp_92 ()):(bdd_op_inputs[10] && (bdd_op_inputs[18]?0:(bdd_op_inputs[26] && cpc_8_cc_2_tmp_92 ()))));
}

static int cpc_8_cc_2_tmp_94 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17] && cpc_8_cc_2_tmp_93 ()):(bdd_op_inputs[9] && (bdd_op_inputs[17]?0:(bdd_op_inputs[25] && cpc_8_cc_2_tmp_93 ()))));
}

static int cpc_8_cc_2_tmp_95 (void) {
  return (bdd_op_inputs[16] && cpc_8_cc_2_tmp_63 ());
}

static int cpc_8_cc_2_tmp_96 (void) {
  return (bdd_op_inputs[7] || (bdd_op_inputs[15]?cpc_8_cc_2_tmp_16 ():cpc_8_cc_2_tmp_17 ()));
}

static int cpc_8_cc_2_tmp_97 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_2_tmp_96 ():cpc_8_cc_2_tmp_68 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpc_8_cc_2_tmp_96 ():cpc_8_cc_2_tmp_51 ())):(bdd_op_inputs[22]?cpc_8_cc_2_tmp_51 ():cpc_8_cc_2_tmp_69 ())));
}

static int cpc_8_cc_2_tmp_98 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_2_tmp_97 ():cpc_8_cc_2_tmp_71 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_2_tmp_97 ():cpc_8_cc_2_tmp_53 ())):(bdd_op_inputs[21]?cpc_8_cc_2_tmp_53 ():cpc_8_cc_2_tmp_72 ())));
}

static int cpc_8_cc_2_tmp_99 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_2_tmp_98 ():cpc_8_cc_2_tmp_74 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_2_tmp_98 ():cpc_8_cc_2_tmp_55 ())):(bdd_op_inputs[20]?cpc_8_cc_2_tmp_55 ():cpc_8_cc_2_tmp_75 ())));
}

static int cpc_8_cc_2_tmp_100 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_2_tmp_99 ():cpc_8_cc_2_tmp_77 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_2_tmp_99 ():cpc_8_cc_2_tmp_57 ())):(bdd_op_inputs[19]?cpc_8_cc_2_tmp_57 ():cpc_8_cc_2_tmp_78 ())));
}

static int cpc_8_cc_2_tmp_101 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_2_tmp_100 ():cpc_8_cc_2_tmp_80 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_2_tmp_100 ():cpc_8_cc_2_tmp_59 ())):(bdd_op_inputs[18]?cpc_8_cc_2_tmp_59 ():cpc_8_cc_2_tmp_81 ())));
}

static int cpc_8_cc_2_tmp_102 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_2_tmp_101 ():cpc_8_cc_2_tmp_83 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_2_tmp_101 ():cpc_8_cc_2_tmp_61 ())):(bdd_op_inputs[17]?cpc_8_cc_2_tmp_61 ():cpc_8_cc_2_tmp_84 ())));
}

static int cpc_8_cc_2_tmp_103 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_2_tmp_102 ():cpc_8_cc_2_tmp_64 ());
}

static int cpc_8_cc_2_tmp_104 (void) {
  return (bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_2_tmp_102 ():cpc_8_cc_2_tmp_85 ()));
}

static int cpc_8_cc_2_tmp_105 (void) {
  return (bdd_op_inputs[15] && cpc_8_cc_2_tmp_16 ());
}

static int cpc_8_cc_2_tmp_106 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_2_tmp_17 ():cpc_8_cc_2_tmp_50 ());
}

static int cpc_8_cc_2_tmp_107 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_2_tmp_106 ());
}

static int cpc_8_cc_2_tmp_108 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_2_tmp_105 ():cpc_8_cc_2_tmp_107 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpc_8_cc_2_tmp_105 ():cpc_8_cc_2_tmp_106 ())):cpc_8_cc_2_tmp_106 ()));
}

static int cpc_8_cc_2_tmp_109 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_2_tmp_106 ():cpc_8_cc_2_tmp_107 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpc_8_cc_2_tmp_106 ()):cpc_8_cc_2_tmp_106 ()));
}

static int cpc_8_cc_2_tmp_110 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_2_tmp_109 ());
}

static int cpc_8_cc_2_tmp_111 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_2_tmp_108 ():cpc_8_cc_2_tmp_110 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_2_tmp_108 ():cpc_8_cc_2_tmp_109 ())):cpc_8_cc_2_tmp_109 ()));
}

static int cpc_8_cc_2_tmp_112 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_2_tmp_109 ():cpc_8_cc_2_tmp_110 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_2_tmp_109 ()):cpc_8_cc_2_tmp_109 ()));
}

static int cpc_8_cc_2_tmp_113 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_2_tmp_112 ());
}

static int cpc_8_cc_2_tmp_114 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_2_tmp_111 ():cpc_8_cc_2_tmp_113 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_2_tmp_111 ():cpc_8_cc_2_tmp_112 ())):cpc_8_cc_2_tmp_112 ()));
}

static int cpc_8_cc_2_tmp_115 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_2_tmp_112 ():cpc_8_cc_2_tmp_113 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_2_tmp_112 ()):cpc_8_cc_2_tmp_112 ()));
}

static int cpc_8_cc_2_tmp_116 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_2_tmp_115 ());
}

static int cpc_8_cc_2_tmp_117 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_2_tmp_114 ():cpc_8_cc_2_tmp_116 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_2_tmp_114 ():cpc_8_cc_2_tmp_115 ())):cpc_8_cc_2_tmp_115 ()));
}

static int cpc_8_cc_2_tmp_118 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_2_tmp_115 ():cpc_8_cc_2_tmp_116 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_2_tmp_115 ()):cpc_8_cc_2_tmp_115 ()));
}

static int cpc_8_cc_2_tmp_119 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_2_tmp_118 ());
}

static int cpc_8_cc_2_tmp_120 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_2_tmp_117 ():cpc_8_cc_2_tmp_119 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_2_tmp_117 ():cpc_8_cc_2_tmp_118 ())):cpc_8_cc_2_tmp_118 ()));
}

static int cpc_8_cc_2_tmp_121 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_2_tmp_118 ():cpc_8_cc_2_tmp_119 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_2_tmp_118 ()):cpc_8_cc_2_tmp_118 ()));
}

static int cpc_8_cc_2_tmp_122 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_2_tmp_121 ());
}

static int cpc_8_cc_2_tmp_123 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_2_tmp_120 ():cpc_8_cc_2_tmp_122 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_2_tmp_120 ():cpc_8_cc_2_tmp_121 ())):cpc_8_cc_2_tmp_121 ()));
}

static int cpc_8_cc_2_tmp_124 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_2_tmp_121 ():cpc_8_cc_2_tmp_122 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpc_8_cc_2_tmp_121 ()):cpc_8_cc_2_tmp_121 ()));
}

static int cpc_8_cc_1_tmp_49 (void) {
  return bdd_op_inputs[23];
}

static int cpc_8_cc_1_tmp_125 (void) {
  return (bdd_op_inputs[15] || cpc_8_cc_1_tmp_49 ());
}

static int cpc_8_cc_1_tmp_126 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_1_tmp_49 ():cpc_8_cc_1_tmp_125 ());
}

static int cpc_8_cc_1_tmp_127 (void) {
  return (bdd_op_inputs[22] && cpc_8_cc_1_tmp_126 ());
}

static int cpc_8_cc_1_tmp_128 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_1_tmp_127 ():(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpc_8_cc_1_tmp_126 ()):cpc_8_cc_1_tmp_127 ()));
}

static int cpc_8_cc_1_tmp_129 (void) {
  return (bdd_op_inputs[21] && cpc_8_cc_1_tmp_128 ());
}

static int cpc_8_cc_1_tmp_130 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_1_tmp_129 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_1_tmp_128 ()):cpc_8_cc_1_tmp_129 ()));
}

static int cpc_8_cc_1_tmp_131 (void) {
  return (bdd_op_inputs[20] && cpc_8_cc_1_tmp_130 ());
}

static int cpc_8_cc_1_tmp_132 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_1_tmp_131 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_1_tmp_130 ()):cpc_8_cc_1_tmp_131 ()));
}

static int cpc_8_cc_1_tmp_133 (void) {
  return (bdd_op_inputs[19] && cpc_8_cc_1_tmp_132 ());
}

static int cpc_8_cc_1_tmp_134 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_1_tmp_133 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_1_tmp_132 ()):cpc_8_cc_1_tmp_133 ()));
}

static int cpc_8_cc_1_tmp_135 (void) {
  return (bdd_op_inputs[18] && cpc_8_cc_1_tmp_134 ());
}

static int cpc_8_cc_1_tmp_136 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_1_tmp_135 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_1_tmp_134 ()):cpc_8_cc_1_tmp_135 ()));
}

static int cpc_8_cc_1_tmp_137 (void) {
  return (bdd_op_inputs[17] && cpc_8_cc_1_tmp_136 ());
}

static int cpc_8_cc_1_tmp_138 (void) {
  return (bdd_op_inputs[1]?cpc_8_cc_1_tmp_137 ():(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpc_8_cc_1_tmp_136 ()):cpc_8_cc_1_tmp_137 ()));
}

static int cpc_8_cc_1_tmp_139 (void) {
  return (bdd_op_inputs[24] || cpc_8_cc_1_tmp_138 ());
}

static int cpc_8_cc_1_tmp_140 (void) {
  return (bdd_op_inputs[24] && cpc_8_cc_1_tmp_138 ());
}

static int cpc_8_cc_1_tmp_141 (void) {
  return (bdd_op_inputs[16]?0:cpc_8_cc_1_tmp_140 ());
}

static int cpc_8_cc_1_tmp_16 (void) {
  return bdd_op_inputs[31];
}

static int cpc_8_cc_1_tmp_142 (void) {
  return (bdd_op_inputs[7] && (bdd_op_inputs[23]?0:cpc_8_cc_1_tmp_16 ()));
}

static int cpc_8_cc_1_tmp_143 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_1_tmp_142 ());
}

static int cpc_8_cc_1_tmp_144 (void) {
  return (bdd_op_inputs[30] && cpc_8_cc_1_tmp_142 ());
}

static int cpc_8_cc_1_tmp_145 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_1_tmp_142 ():cpc_8_cc_1_tmp_143 ()):(bdd_op_inputs[22]?0:cpc_8_cc_1_tmp_144 ()));
}

static int cpc_8_cc_1_tmp_146 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_1_tmp_145 ());
}

static int cpc_8_cc_1_tmp_147 (void) {
  return (bdd_op_inputs[29] && cpc_8_cc_1_tmp_145 ());
}

static int cpc_8_cc_1_tmp_148 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_1_tmp_145 ():cpc_8_cc_1_tmp_146 ()):(bdd_op_inputs[21]?0:cpc_8_cc_1_tmp_147 ()));
}

static int cpc_8_cc_1_tmp_149 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_1_tmp_148 ());
}

static int cpc_8_cc_1_tmp_150 (void) {
  return (bdd_op_inputs[28] && cpc_8_cc_1_tmp_148 ());
}

static int cpc_8_cc_1_tmp_151 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_1_tmp_148 ():cpc_8_cc_1_tmp_149 ()):(bdd_op_inputs[20]?0:cpc_8_cc_1_tmp_150 ()));
}

static int cpc_8_cc_1_tmp_152 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_1_tmp_151 ());
}

static int cpc_8_cc_1_tmp_153 (void) {
  return (bdd_op_inputs[27] && cpc_8_cc_1_tmp_151 ());
}

static int cpc_8_cc_1_tmp_154 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_1_tmp_151 ():cpc_8_cc_1_tmp_152 ()):(bdd_op_inputs[19]?0:cpc_8_cc_1_tmp_153 ()));
}

static int cpc_8_cc_1_tmp_155 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_1_tmp_154 ());
}

static int cpc_8_cc_1_tmp_156 (void) {
  return (bdd_op_inputs[26] && cpc_8_cc_1_tmp_154 ());
}

static int cpc_8_cc_1_tmp_157 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_1_tmp_154 ():cpc_8_cc_1_tmp_155 ()):(bdd_op_inputs[18]?0:cpc_8_cc_1_tmp_156 ()));
}

static int cpc_8_cc_1_tmp_158 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_1_tmp_157 ());
}

static int cpc_8_cc_1_tmp_159 (void) {
  return (bdd_op_inputs[25] && cpc_8_cc_1_tmp_157 ());
}

static int cpc_8_cc_1_tmp_160 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_1_tmp_157 ():cpc_8_cc_1_tmp_158 ()):(bdd_op_inputs[17]?0:cpc_8_cc_1_tmp_159 ()));
}

static int cpc_8_cc_1_tmp_161 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_1_tmp_138 ():(bdd_op_inputs[24] && cpc_8_cc_1_tmp_160 ()));
}

static int cpc_8_cc_1_tmp_162 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_1_tmp_160 ():cpc_8_cc_1_tmp_140 ());
}

static int cpc_8_cc_1_tmp_163 (void) {
  return (bdd_op_inputs[16] && cpc_8_cc_1_tmp_138 ());
}

static int cpc_8_cc_1_tmp_164 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_1_tmp_16 ():cpc_8_cc_1_tmp_125 ());
}

static int cpc_8_cc_1_tmp_165 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_1_tmp_164 ():cpc_8_cc_1_tmp_143 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpc_8_cc_1_tmp_164 ():cpc_8_cc_1_tmp_126 ())):(bdd_op_inputs[22]?cpc_8_cc_1_tmp_126 ():cpc_8_cc_1_tmp_144 ())));
}

static int cpc_8_cc_1_tmp_166 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_1_tmp_165 ():cpc_8_cc_1_tmp_146 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_1_tmp_165 ():cpc_8_cc_1_tmp_128 ())):(bdd_op_inputs[21]?cpc_8_cc_1_tmp_128 ():cpc_8_cc_1_tmp_147 ())));
}

static int cpc_8_cc_1_tmp_167 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_1_tmp_166 ():cpc_8_cc_1_tmp_149 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_1_tmp_166 ():cpc_8_cc_1_tmp_130 ())):(bdd_op_inputs[20]?cpc_8_cc_1_tmp_130 ():cpc_8_cc_1_tmp_150 ())));
}

static int cpc_8_cc_1_tmp_168 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_1_tmp_167 ():cpc_8_cc_1_tmp_152 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_1_tmp_167 ():cpc_8_cc_1_tmp_132 ())):(bdd_op_inputs[19]?cpc_8_cc_1_tmp_132 ():cpc_8_cc_1_tmp_153 ())));
}

static int cpc_8_cc_1_tmp_169 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_1_tmp_168 ():cpc_8_cc_1_tmp_155 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_1_tmp_168 ():cpc_8_cc_1_tmp_134 ())):(bdd_op_inputs[18]?cpc_8_cc_1_tmp_134 ():cpc_8_cc_1_tmp_156 ())));
}

static int cpc_8_cc_1_tmp_170 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_1_tmp_169 ():cpc_8_cc_1_tmp_158 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_1_tmp_169 ():cpc_8_cc_1_tmp_136 ())):(bdd_op_inputs[17]?cpc_8_cc_1_tmp_136 ():cpc_8_cc_1_tmp_159 ())));
}

static int cpc_8_cc_1_tmp_171 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_1_tmp_170 ():cpc_8_cc_1_tmp_139 ());
}

static int cpc_8_cc_1_tmp_172 (void) {
  return (bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_1_tmp_170 ():cpc_8_cc_1_tmp_160 ()));
}

static int cpc_8_cc_3_tmp_49 (void) {
  return bdd_op_inputs[23];
}

static int cpc_8_cc_3_tmp_173 (void) {
  return (bdd_op_inputs[15] || cpc_8_cc_3_tmp_49 ());
}

static int cpc_8_cc_3_tmp_174 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_3_tmp_49 ():cpc_8_cc_3_tmp_173 ());
}

static int cpc_8_cc_3_tmp_175 (void) {
  return (bdd_op_inputs[22] && cpc_8_cc_3_tmp_174 ());
}

static int cpc_8_cc_3_tmp_176 (void) {
  return (bdd_op_inputs[22] || cpc_8_cc_3_tmp_174 ());
}

static int cpc_8_cc_3_tmp_177 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_3_tmp_175 ():(bdd_op_inputs[14]?cpc_8_cc_3_tmp_176 ():cpc_8_cc_3_tmp_175 ()));
}

static int cpc_8_cc_3_tmp_178 (void) {
  return (bdd_op_inputs[21] && cpc_8_cc_3_tmp_177 ());
}

static int cpc_8_cc_3_tmp_179 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_3_tmp_178 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_3_tmp_177 ()):cpc_8_cc_3_tmp_178 ()));
}

static int cpc_8_cc_3_tmp_180 (void) {
  return (bdd_op_inputs[20] && cpc_8_cc_3_tmp_179 ());
}

static int cpc_8_cc_3_tmp_181 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_3_tmp_180 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_3_tmp_179 ()):cpc_8_cc_3_tmp_180 ()));
}

static int cpc_8_cc_3_tmp_182 (void) {
  return (bdd_op_inputs[19] && cpc_8_cc_3_tmp_181 ());
}

static int cpc_8_cc_3_tmp_183 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_3_tmp_182 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_3_tmp_181 ()):cpc_8_cc_3_tmp_182 ()));
}

static int cpc_8_cc_3_tmp_184 (void) {
  return (bdd_op_inputs[18] && cpc_8_cc_3_tmp_183 ());
}

static int cpc_8_cc_3_tmp_185 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_3_tmp_184 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_3_tmp_183 ()):cpc_8_cc_3_tmp_184 ()));
}

static int cpc_8_cc_3_tmp_186 (void) {
  return (bdd_op_inputs[17] && cpc_8_cc_3_tmp_185 ());
}

static int cpc_8_cc_3_tmp_187 (void) {
  return (bdd_op_inputs[1]?cpc_8_cc_3_tmp_186 ():(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpc_8_cc_3_tmp_185 ()):cpc_8_cc_3_tmp_186 ()));
}

static int cpc_8_cc_3_tmp_188 (void) {
  return (bdd_op_inputs[24] || cpc_8_cc_3_tmp_187 ());
}

static int cpc_8_cc_3_tmp_189 (void) {
  return (bdd_op_inputs[24] && cpc_8_cc_3_tmp_187 ());
}

static int cpc_8_cc_3_tmp_190 (void) {
  return (bdd_op_inputs[16]?0:cpc_8_cc_3_tmp_189 ());
}

static int cpc_8_cc_3_tmp_16 (void) {
  return bdd_op_inputs[31];
}

static int cpc_8_cc_3_tmp_17 (void) {
  return (bdd_op_inputs[23]?0:cpc_8_cc_3_tmp_16 ());
}

static int cpc_8_cc_3_tmp_191 (void) {
  return (bdd_op_inputs[7] && cpc_8_cc_3_tmp_17 ());
}

static int cpc_8_cc_3_tmp_192 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_3_tmp_191 ());
}

static int cpc_8_cc_3_tmp_193 (void) {
  return (bdd_op_inputs[30] && cpc_8_cc_3_tmp_191 ());
}

static int cpc_8_cc_3_tmp_194 (void) {
  return (bdd_op_inputs[22]?0:cpc_8_cc_3_tmp_193 ());
}

static int cpc_8_cc_3_tmp_195 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_191 ():cpc_8_cc_3_tmp_192 ()):cpc_8_cc_3_tmp_194 ());
}

static int cpc_8_cc_3_tmp_196 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_3_tmp_195 ());
}

static int cpc_8_cc_3_tmp_197 (void) {
  return (bdd_op_inputs[29] && cpc_8_cc_3_tmp_195 ());
}

static int cpc_8_cc_3_tmp_198 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_195 ():cpc_8_cc_3_tmp_196 ()):(bdd_op_inputs[21]?0:cpc_8_cc_3_tmp_197 ()));
}

static int cpc_8_cc_3_tmp_199 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_3_tmp_198 ());
}

static int cpc_8_cc_3_tmp_200 (void) {
  return (bdd_op_inputs[28] && cpc_8_cc_3_tmp_198 ());
}

static int cpc_8_cc_3_tmp_201 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_198 ():cpc_8_cc_3_tmp_199 ()):(bdd_op_inputs[20]?0:cpc_8_cc_3_tmp_200 ()));
}

static int cpc_8_cc_3_tmp_202 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_3_tmp_201 ());
}

static int cpc_8_cc_3_tmp_203 (void) {
  return (bdd_op_inputs[27] && cpc_8_cc_3_tmp_201 ());
}

static int cpc_8_cc_3_tmp_204 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_201 ():cpc_8_cc_3_tmp_202 ()):(bdd_op_inputs[19]?0:cpc_8_cc_3_tmp_203 ()));
}

static int cpc_8_cc_3_tmp_205 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_3_tmp_204 ());
}

static int cpc_8_cc_3_tmp_206 (void) {
  return (bdd_op_inputs[26] && cpc_8_cc_3_tmp_204 ());
}

static int cpc_8_cc_3_tmp_207 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_204 ():cpc_8_cc_3_tmp_205 ()):(bdd_op_inputs[18]?0:cpc_8_cc_3_tmp_206 ()));
}

static int cpc_8_cc_3_tmp_208 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_3_tmp_207 ());
}

static int cpc_8_cc_3_tmp_209 (void) {
  return (bdd_op_inputs[25] && cpc_8_cc_3_tmp_207 ());
}

static int cpc_8_cc_3_tmp_210 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_207 ():cpc_8_cc_3_tmp_208 ()):(bdd_op_inputs[17]?0:cpc_8_cc_3_tmp_209 ()));
}

static int cpc_8_cc_3_tmp_211 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_3_tmp_187 ():(bdd_op_inputs[24] && cpc_8_cc_3_tmp_210 ()));
}

static int cpc_8_cc_3_tmp_212 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_3_tmp_210 ():cpc_8_cc_3_tmp_189 ());
}

static int cpc_8_cc_3_tmp_213 (void) {
  return (bdd_op_inputs[7]?0:(bdd_op_inputs[15] && cpc_8_cc_3_tmp_49 ()));
}

static int cpc_8_cc_3_tmp_214 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_191 ():(bdd_op_inputs[30] && cpc_8_cc_3_tmp_213 ())):(bdd_op_inputs[14] && cpc_8_cc_3_tmp_194 ()));
}

static int cpc_8_cc_3_tmp_215 (void) {
  return (bdd_op_inputs[6]?0:(bdd_op_inputs[14] && (bdd_op_inputs[22] && cpc_8_cc_3_tmp_213 ())));
}

static int cpc_8_cc_3_tmp_216 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_214 ():(bdd_op_inputs[29] && cpc_8_cc_3_tmp_215 ())):(bdd_op_inputs[13] && (bdd_op_inputs[21]?0:(bdd_op_inputs[29] && cpc_8_cc_3_tmp_214 ()))));
}

static int cpc_8_cc_3_tmp_4 (void) {
  return (bdd_op_inputs[5]?0:(bdd_op_inputs[13] && (bdd_op_inputs[21] && cpc_8_cc_3_tmp_215 ())));
}

static int cpc_8_cc_3_tmp_217 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_216 ():(bdd_op_inputs[28] && cpc_8_cc_3_tmp_4 ())):(bdd_op_inputs[12] && (bdd_op_inputs[20]?0:(bdd_op_inputs[28] && cpc_8_cc_3_tmp_216 ()))));
}

static int cpc_8_cc_3_tmp_9 (void) {
  return (bdd_op_inputs[4]?0:(bdd_op_inputs[12] && (bdd_op_inputs[20] && cpc_8_cc_3_tmp_4 ())));
}

static int cpc_8_cc_3_tmp_10 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_217 ():(bdd_op_inputs[27] && cpc_8_cc_3_tmp_9 ())):(bdd_op_inputs[11] && (bdd_op_inputs[19]?0:(bdd_op_inputs[27] && cpc_8_cc_3_tmp_217 ()))));
}

static int cpc_8_cc_3_tmp_15 (void) {
  return (bdd_op_inputs[3]?0:(bdd_op_inputs[11] && (bdd_op_inputs[19] && cpc_8_cc_3_tmp_9 ())));
}

static int cpc_8_cc_3_tmp_218 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_10 ():(bdd_op_inputs[26] && cpc_8_cc_3_tmp_15 ())):(bdd_op_inputs[10] && (bdd_op_inputs[18]?0:(bdd_op_inputs[26] && cpc_8_cc_3_tmp_10 ()))));
}

static int cpc_8_cc_3_tmp_21 (void) {
  return (bdd_op_inputs[2]?0:(bdd_op_inputs[10] && (bdd_op_inputs[18] && cpc_8_cc_3_tmp_15 ())));
}

static int cpc_8_cc_3_tmp_22 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_218 ():(bdd_op_inputs[25] && cpc_8_cc_3_tmp_21 ())):(bdd_op_inputs[9] && (bdd_op_inputs[17]?0:(bdd_op_inputs[25] && cpc_8_cc_3_tmp_218 ()))));
}

static int cpc_8_cc_3_tmp_219 (void) {
  return (bdd_op_inputs[1]?0:(bdd_op_inputs[9] && (bdd_op_inputs[17] && cpc_8_cc_3_tmp_21 ())));
}

static int cpc_8_cc_3_tmp_28 (void) {
  return (bdd_op_inputs[16] && cpc_8_cc_3_tmp_187 ());
}

static int cpc_8_cc_3_tmp_33 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_3_tmp_16 ():cpc_8_cc_3_tmp_173 ());
}

static int cpc_8_cc_3_tmp_220 (void) {
  return (bdd_op_inputs[22] || (bdd_op_inputs[30]?cpc_8_cc_3_tmp_33 ():cpc_8_cc_3_tmp_174 ()));
}

static int cpc_8_cc_3_tmp_36 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_33 ():cpc_8_cc_3_tmp_192 ()):(bdd_op_inputs[14]?cpc_8_cc_3_tmp_220 ():(bdd_op_inputs[22]?cpc_8_cc_3_tmp_174 ():cpc_8_cc_3_tmp_193 ())));
}

static int cpc_8_cc_3_tmp_221 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_36 ():cpc_8_cc_3_tmp_196 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_3_tmp_36 ():cpc_8_cc_3_tmp_177 ())):(bdd_op_inputs[21]?cpc_8_cc_3_tmp_177 ():cpc_8_cc_3_tmp_197 ())));
}

static int cpc_8_cc_3_tmp_222 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_221 ():cpc_8_cc_3_tmp_199 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_3_tmp_221 ():cpc_8_cc_3_tmp_179 ())):(bdd_op_inputs[20]?cpc_8_cc_3_tmp_179 ():cpc_8_cc_3_tmp_200 ())));
}

static int cpc_8_cc_3_tmp_223 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_222 ():cpc_8_cc_3_tmp_202 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_3_tmp_222 ():cpc_8_cc_3_tmp_181 ())):(bdd_op_inputs[19]?cpc_8_cc_3_tmp_181 ():cpc_8_cc_3_tmp_203 ())));
}

static int cpc_8_cc_3_tmp_224 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_223 ():cpc_8_cc_3_tmp_205 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_3_tmp_223 ():cpc_8_cc_3_tmp_183 ())):(bdd_op_inputs[18]?cpc_8_cc_3_tmp_183 ():cpc_8_cc_3_tmp_206 ())));
}

static int cpc_8_cc_3_tmp_225 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_224 ():cpc_8_cc_3_tmp_208 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_3_tmp_224 ():cpc_8_cc_3_tmp_185 ())):(bdd_op_inputs[17]?cpc_8_cc_3_tmp_185 ():cpc_8_cc_3_tmp_209 ())));
}

static int cpc_8_cc_3_tmp_226 (void) {
  return (bdd_op_inputs[16]?cpc_8_cc_3_tmp_225 ():cpc_8_cc_3_tmp_188 ());
}

static int cpc_8_cc_3_tmp_227 (void) {
  return (bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_3_tmp_225 ():cpc_8_cc_3_tmp_210 ()));
}

static int cpc_8_cc_3_tmp_228 (void) {
  return (bdd_op_inputs[7] || (bdd_op_inputs[15]?cpc_8_cc_3_tmp_16 ():cpc_8_cc_3_tmp_17 ()));
}

static int cpc_8_cc_3_tmp_229 (void) {
  return (bdd_op_inputs[7]?cpc_8_cc_3_tmp_49 ():(bdd_op_inputs[15] && cpc_8_cc_3_tmp_17 ()));
}

static int cpc_8_cc_3_tmp_230 (void) {
  return (bdd_op_inputs[22]?cpc_8_cc_3_tmp_174 ():cpc_8_cc_3_tmp_229 ());
}

static int cpc_8_cc_3_tmp_231 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_33 ():(bdd_op_inputs[30]?cpc_8_cc_3_tmp_228 ():cpc_8_cc_3_tmp_229 ())):(bdd_op_inputs[14]?cpc_8_cc_3_tmp_220 ():cpc_8_cc_3_tmp_230 ()));
}

static int cpc_8_cc_3_tmp_232 (void) {
  return (bdd_op_inputs[7] || cpc_8_cc_3_tmp_17 ());
}

static int cpc_8_cc_3_tmp_233 (void) {
  return (bdd_op_inputs[30] || cpc_8_cc_3_tmp_232 ());
}

static int cpc_8_cc_3_tmp_48 (void) {
  return (bdd_op_inputs[22]?cpc_8_cc_3_tmp_232 ():cpc_8_cc_3_tmp_233 ());
}

static int cpc_8_cc_3_tmp_234 (void) {
  return (bdd_op_inputs[6] || (bdd_op_inputs[14]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_228 ():cpc_8_cc_3_tmp_233 ()):cpc_8_cc_3_tmp_48 ()));
}

static int cpc_8_cc_3_tmp_45 (void) {
  return (bdd_op_inputs[22]?cpc_8_cc_3_tmp_174 ():(bdd_op_inputs[30]?cpc_8_cc_3_tmp_232 ():cpc_8_cc_3_tmp_229 ()));
}

static int cpc_8_cc_3_tmp_235 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_3_tmp_45 ():(bdd_op_inputs[14]?(bdd_op_inputs[22]?cpc_8_cc_3_tmp_232 ():(bdd_op_inputs[30]?cpc_8_cc_3_tmp_174 ():cpc_8_cc_3_tmp_229 ())):cpc_8_cc_3_tmp_229 ()));
}

static int cpc_8_cc_3_tmp_236 (void) {
  return (bdd_op_inputs[6]?cpc_8_cc_3_tmp_45 ():(bdd_op_inputs[14]?cpc_8_cc_3_tmp_176 ():cpc_8_cc_3_tmp_230 ()));
}

static int cpc_8_cc_3_tmp_237 (void) {
  return (bdd_op_inputs[21]?cpc_8_cc_3_tmp_236 ():cpc_8_cc_3_tmp_235 ());
}

static int cpc_8_cc_3_tmp_238 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_231 ():(bdd_op_inputs[29]?cpc_8_cc_3_tmp_234 ():cpc_8_cc_3_tmp_235 ())):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpc_8_cc_3_tmp_231 ():cpc_8_cc_3_tmp_236 ())):cpc_8_cc_3_tmp_237 ()));
}

static int cpc_8_cc_3_tmp_239 (void) {
  return (bdd_op_inputs[6] || cpc_8_cc_3_tmp_48 ());
}

static int cpc_8_cc_3_tmp_240 (void) {
  return (bdd_op_inputs[29] || cpc_8_cc_3_tmp_239 ());
}

static int cpc_8_cc_3_tmp_241 (void) {
  return (bdd_op_inputs[21]?cpc_8_cc_3_tmp_239 ():cpc_8_cc_3_tmp_240 ());
}

static int cpc_8_cc_3_tmp_242 (void) {
  return (bdd_op_inputs[5] || (bdd_op_inputs[13]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_234 ():cpc_8_cc_3_tmp_240 ()):cpc_8_cc_3_tmp_241 ()));
}

static int cpc_8_cc_3_tmp_243 (void) {
  return (bdd_op_inputs[21]?cpc_8_cc_3_tmp_236 ():(bdd_op_inputs[29]?cpc_8_cc_3_tmp_239 ():cpc_8_cc_3_tmp_235 ()));
}

static int cpc_8_cc_3_tmp_244 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_3_tmp_243 ():(bdd_op_inputs[13]?(bdd_op_inputs[21]?cpc_8_cc_3_tmp_239 ():(bdd_op_inputs[29]?cpc_8_cc_3_tmp_236 ():cpc_8_cc_3_tmp_235 ())):cpc_8_cc_3_tmp_235 ()));
}

static int cpc_8_cc_3_tmp_245 (void) {
  return (bdd_op_inputs[5]?cpc_8_cc_3_tmp_243 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpc_8_cc_3_tmp_236 ()):cpc_8_cc_3_tmp_237 ()));
}

static int cpc_8_cc_3_tmp_246 (void) {
  return (bdd_op_inputs[20]?cpc_8_cc_3_tmp_245 ():cpc_8_cc_3_tmp_244 ());
}

static int cpc_8_cc_3_tmp_247 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_238 ():(bdd_op_inputs[28]?cpc_8_cc_3_tmp_242 ():cpc_8_cc_3_tmp_244 ())):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpc_8_cc_3_tmp_238 ():cpc_8_cc_3_tmp_245 ())):cpc_8_cc_3_tmp_246 ()));
}

static int cpc_8_cc_3_tmp_248 (void) {
  return (bdd_op_inputs[5] || cpc_8_cc_3_tmp_241 ());
}

static int cpc_8_cc_3_tmp_249 (void) {
  return (bdd_op_inputs[28] || cpc_8_cc_3_tmp_248 ());
}

static int cpc_8_cc_3_tmp_250 (void) {
  return (bdd_op_inputs[20]?cpc_8_cc_3_tmp_248 ():cpc_8_cc_3_tmp_249 ());
}

static int cpc_8_cc_3_tmp_251 (void) {
  return (bdd_op_inputs[4] || (bdd_op_inputs[12]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_242 ():cpc_8_cc_3_tmp_249 ()):cpc_8_cc_3_tmp_250 ()));
}

static int cpc_8_cc_3_tmp_252 (void) {
  return (bdd_op_inputs[20]?cpc_8_cc_3_tmp_245 ():(bdd_op_inputs[28]?cpc_8_cc_3_tmp_248 ():cpc_8_cc_3_tmp_244 ()));
}

static int cpc_8_cc_3_tmp_253 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_3_tmp_252 ():(bdd_op_inputs[12]?(bdd_op_inputs[20]?cpc_8_cc_3_tmp_248 ():(bdd_op_inputs[28]?cpc_8_cc_3_tmp_245 ():cpc_8_cc_3_tmp_244 ())):cpc_8_cc_3_tmp_244 ()));
}

static int cpc_8_cc_3_tmp_254 (void) {
  return (bdd_op_inputs[4]?cpc_8_cc_3_tmp_252 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpc_8_cc_3_tmp_245 ()):cpc_8_cc_3_tmp_246 ()));
}

static int cpc_8_cc_3_tmp_255 (void) {
  return (bdd_op_inputs[19]?cpc_8_cc_3_tmp_254 ():cpc_8_cc_3_tmp_253 ());
}

static int cpc_8_cc_3_tmp_256 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_247 ():(bdd_op_inputs[27]?cpc_8_cc_3_tmp_251 ():cpc_8_cc_3_tmp_253 ())):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpc_8_cc_3_tmp_247 ():cpc_8_cc_3_tmp_254 ())):cpc_8_cc_3_tmp_255 ()));
}

static int cpc_8_cc_3_tmp_257 (void) {
  return (bdd_op_inputs[4] || cpc_8_cc_3_tmp_250 ());
}

static int cpc_8_cc_3_tmp_258 (void) {
  return (bdd_op_inputs[27] || cpc_8_cc_3_tmp_257 ());
}

static int cpc_8_cc_3_tmp_259 (void) {
  return (bdd_op_inputs[19]?cpc_8_cc_3_tmp_257 ():cpc_8_cc_3_tmp_258 ());
}

static int cpc_8_cc_3_tmp_260 (void) {
  return (bdd_op_inputs[3] || (bdd_op_inputs[11]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_251 ():cpc_8_cc_3_tmp_258 ()):cpc_8_cc_3_tmp_259 ()));
}

static int cpc_8_cc_3_tmp_261 (void) {
  return (bdd_op_inputs[19]?cpc_8_cc_3_tmp_254 ():(bdd_op_inputs[27]?cpc_8_cc_3_tmp_257 ():cpc_8_cc_3_tmp_253 ()));
}

static int cpc_8_cc_3_tmp_262 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_3_tmp_261 ():(bdd_op_inputs[11]?(bdd_op_inputs[19]?cpc_8_cc_3_tmp_257 ():(bdd_op_inputs[27]?cpc_8_cc_3_tmp_254 ():cpc_8_cc_3_tmp_253 ())):cpc_8_cc_3_tmp_253 ()));
}

static int cpc_8_cc_3_tmp_263 (void) {
  return (bdd_op_inputs[3]?cpc_8_cc_3_tmp_261 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpc_8_cc_3_tmp_254 ()):cpc_8_cc_3_tmp_255 ()));
}

static int cpc_8_cc_3_tmp_264 (void) {
  return (bdd_op_inputs[18]?cpc_8_cc_3_tmp_263 ():cpc_8_cc_3_tmp_262 ());
}

static int cpc_8_cc_3_tmp_265 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_256 ():(bdd_op_inputs[26]?cpc_8_cc_3_tmp_260 ():cpc_8_cc_3_tmp_262 ())):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpc_8_cc_3_tmp_256 ():cpc_8_cc_3_tmp_263 ())):cpc_8_cc_3_tmp_264 ()));
}

static int cpc_8_cc_3_tmp_266 (void) {
  return (bdd_op_inputs[3] || cpc_8_cc_3_tmp_259 ());
}

static int cpc_8_cc_3_tmp_267 (void) {
  return (bdd_op_inputs[26] || cpc_8_cc_3_tmp_266 ());
}

static int cpc_8_cc_3_tmp_268 (void) {
  return (bdd_op_inputs[18]?cpc_8_cc_3_tmp_266 ():cpc_8_cc_3_tmp_267 ());
}

static int cpc_8_cc_3_tmp_269 (void) {
  return (bdd_op_inputs[2] || (bdd_op_inputs[10]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_260 ():cpc_8_cc_3_tmp_267 ()):cpc_8_cc_3_tmp_268 ()));
}

static int cpc_8_cc_3_tmp_270 (void) {
  return (bdd_op_inputs[18]?cpc_8_cc_3_tmp_263 ():(bdd_op_inputs[26]?cpc_8_cc_3_tmp_266 ():cpc_8_cc_3_tmp_262 ()));
}

static int cpc_8_cc_3_tmp_271 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_3_tmp_270 ():(bdd_op_inputs[10]?(bdd_op_inputs[18]?cpc_8_cc_3_tmp_266 ():(bdd_op_inputs[26]?cpc_8_cc_3_tmp_263 ():cpc_8_cc_3_tmp_262 ())):cpc_8_cc_3_tmp_262 ()));
}

static int cpc_8_cc_3_tmp_272 (void) {
  return (bdd_op_inputs[2]?cpc_8_cc_3_tmp_270 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpc_8_cc_3_tmp_263 ()):cpc_8_cc_3_tmp_264 ()));
}

static int cpc_8_cc_3_tmp_273 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_265 ():(bdd_op_inputs[25]?cpc_8_cc_3_tmp_269 ():cpc_8_cc_3_tmp_271 ())):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpc_8_cc_3_tmp_265 ():cpc_8_cc_3_tmp_272 ())):(bdd_op_inputs[17]?cpc_8_cc_3_tmp_272 ():cpc_8_cc_3_tmp_271 ())));
}

static int cpc_8_cc_3_tmp_274 (void) {
  return (bdd_op_inputs[2] || cpc_8_cc_3_tmp_268 ());
}

static int cpc_8_cc_3_tmp_275 (void) {
  return (bdd_op_inputs[25] || cpc_8_cc_3_tmp_274 ());
}

static int cpc_8_cc_3_tmp_276 (void) {
  return (bdd_op_inputs[1] || (bdd_op_inputs[9]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_269 ():cpc_8_cc_3_tmp_275 ()):(bdd_op_inputs[17]?cpc_8_cc_3_tmp_274 ():cpc_8_cc_3_tmp_275 ())));
}

static int cpc_8_cc_3_tmp_277 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_272 ():(bdd_op_inputs[25]?cpc_8_cc_3_tmp_274 ():cpc_8_cc_3_tmp_271 ())):(bdd_op_inputs[9]?(bdd_op_inputs[17]?cpc_8_cc_3_tmp_274 ():(bdd_op_inputs[25]?cpc_8_cc_3_tmp_272 ():cpc_8_cc_3_tmp_271 ())):cpc_8_cc_3_tmp_271 ()));
}

struct mem_loc_t bdd_bitbit_cpc_cc (struct mem_loc_t in1, struct mem_loc_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2.val, bdd_op_inputs, 2 * 8);
  explode (in2.known, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x3; ++cc_value) {
    if ((cc.val & cc.known & 0x3) != 
	(cc_value & cc.known & 0x3)) continue;
    if ((cc_value & ~0x3) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = cpc_8_cc_0_tmp_6 ();
  // bitbit_03_0_8.bdd
  outputs[3] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_0_tmp_12 ():cpc_8_cc_0_tmp_13 ()):cpc_8_cc_0_tmp_15 ());
  // bitbit_04_0_8.bdd
  outputs[4] = (bdd_op_inputs[0]?cpc_8_cc_0_tmp_15 ():(bdd_op_inputs[8] && (bdd_op_inputs[16] && cpc_8_cc_0_tmp_36 ())));
  // bitbit_05_0_8.bdd
  outputs[5] = (bdd_op_inputs[0]?cpc_8_cc_0_tmp_37 ():(bdd_op_inputs[8] && cpc_8_cc_0_tmp_38 ()));
  // bitbit_06_0_8.bdd
  outputs[6] = 0;
  // bitbit_07_0_8.bdd
  outputs[7] = (bdd_op_inputs[0]?cpc_8_cc_0_tmp_39 ():(bdd_op_inputs[8]?(bdd_op_inputs[16] || cpc_8_cc_0_tmp_12 ()):cpc_8_cc_0_tmp_39 ()));
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = cpc_8_cc_0_tmp_43 ();
  // bitbit_11_0_8.bdd
  outputs[11] = (bdd_op_inputs[0]?cpc_8_cc_0_tmp_47 ():(bdd_op_inputs[8]?cpc_8_cc_0_tmp_48 ():cpc_8_cc_0_tmp_38 ()));
  // bitbit_12_0_8.bdd
  outputs[12] = (bdd_op_inputs[0]?cpc_8_cc_0_tmp_48 ():(bdd_op_inputs[8]?cpc_8_cc_0_tmp_47 ():cpc_8_cc_0_tmp_37 ()));
  // bitbit_13_0_8.bdd
  outputs[13] = (bdd_op_inputs[8] && (bdd_op_inputs[24] && cpc_8_cc_0_tmp_46 ()));
  // bitbit_14_0_8.bdd
  outputs[14] = 1;
  // bitbit_15_0_8.bdd
  outputs[15] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_0_tmp_46 ():(bdd_op_inputs[24] || cpc_8_cc_0_tmp_36 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_0_tmp_46 ():cpc_8_cc_0_tmp_12 ())):cpc_8_cc_0_tmp_37 ()));
  break;

case 2:
  // bitbit_00_2_8.bdd
  outputs[0] = 0;
  // bitbit_01_2_8.bdd
  outputs[1] = 0;
  // bitbit_02_2_8.bdd
  outputs[2] = cpc_8_cc_2_tmp_57 ();
  // bitbit_03_2_8.bdd
  outputs[3] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_2_tmp_63 ():cpc_8_cc_2_tmp_64 ()):cpc_8_cc_2_tmp_66 ());
  // bitbit_04_2_8.bdd
  outputs[4] = (bdd_op_inputs[0]?cpc_8_cc_2_tmp_66 ():(bdd_op_inputs[8] && (bdd_op_inputs[16] && cpc_8_cc_2_tmp_85 ())));
  // bitbit_05_2_8.bdd
  outputs[5] = (bdd_op_inputs[0]?cpc_8_cc_2_tmp_86 ():(bdd_op_inputs[8] && cpc_8_cc_2_tmp_87 ()));
  // bitbit_06_2_8.bdd
  outputs[6] = (bdd_op_inputs[0]?(bdd_op_inputs[16] && cpc_8_cc_2_tmp_94 ()):(bdd_op_inputs[8] && (bdd_op_inputs[16]?0:(bdd_op_inputs[24] && cpc_8_cc_2_tmp_94 ()))));
  // bitbit_07_2_8.bdd
  outputs[7] = (bdd_op_inputs[0]?cpc_8_cc_2_tmp_95 ():(bdd_op_inputs[8]?(bdd_op_inputs[16] || cpc_8_cc_2_tmp_63 ()):cpc_8_cc_2_tmp_95 ()));
  // bitbit_08_2_8.bdd
  outputs[8] = 1;
  // bitbit_09_2_8.bdd
  outputs[9] = 1;
  // bitbit_10_2_8.bdd
  outputs[10] = cpc_8_cc_2_tmp_99 ();
  // bitbit_11_2_8.bdd
  outputs[11] = (bdd_op_inputs[0]?cpc_8_cc_2_tmp_103 ():(bdd_op_inputs[8]?cpc_8_cc_2_tmp_104 ():cpc_8_cc_2_tmp_87 ()));
  // bitbit_12_2_8.bdd
  outputs[12] = (bdd_op_inputs[0]?cpc_8_cc_2_tmp_104 ():(bdd_op_inputs[8]?cpc_8_cc_2_tmp_103 ():cpc_8_cc_2_tmp_86 ()));
  // bitbit_13_2_8.bdd
  outputs[13] = (bdd_op_inputs[8] && (bdd_op_inputs[24] && cpc_8_cc_2_tmp_102 ()));
  // bitbit_14_2_8.bdd
  outputs[14] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_2_tmp_123 ():(bdd_op_inputs[24] || cpc_8_cc_2_tmp_124 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_2_tmp_123 ():cpc_8_cc_2_tmp_124 ())):cpc_8_cc_2_tmp_124 ()));
  // bitbit_15_2_8.bdd
  outputs[15] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_2_tmp_102 ():(bdd_op_inputs[24] || cpc_8_cc_2_tmp_85 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_2_tmp_102 ():cpc_8_cc_2_tmp_63 ())):cpc_8_cc_2_tmp_86 ()));
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = 0;
  // bitbit_01_1_8.bdd
  outputs[1] = 0;
  // bitbit_02_1_8.bdd
  outputs[2] = cpc_8_cc_1_tmp_132 ();
  // bitbit_03_1_8.bdd
  outputs[3] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_1_tmp_138 ():cpc_8_cc_1_tmp_139 ()):cpc_8_cc_1_tmp_141 ());
  // bitbit_04_1_8.bdd
  outputs[4] = (bdd_op_inputs[0]?cpc_8_cc_1_tmp_141 ():(bdd_op_inputs[8] && (bdd_op_inputs[16] && cpc_8_cc_1_tmp_160 ())));
  // bitbit_05_1_8.bdd
  outputs[5] = (bdd_op_inputs[0]?cpc_8_cc_1_tmp_161 ():(bdd_op_inputs[8] && cpc_8_cc_1_tmp_162 ()));
  // bitbit_06_1_8.bdd
  outputs[6] = 0;
  // bitbit_07_1_8.bdd
  outputs[7] = (bdd_op_inputs[0]?cpc_8_cc_1_tmp_163 ():(bdd_op_inputs[8]?(bdd_op_inputs[16] || cpc_8_cc_1_tmp_138 ()):cpc_8_cc_1_tmp_163 ()));
  // bitbit_08_1_8.bdd
  outputs[8] = 1;
  // bitbit_09_1_8.bdd
  outputs[9] = 1;
  // bitbit_10_1_8.bdd
  outputs[10] = cpc_8_cc_1_tmp_167 ();
  // bitbit_11_1_8.bdd
  outputs[11] = (bdd_op_inputs[0]?cpc_8_cc_1_tmp_171 ():(bdd_op_inputs[8]?cpc_8_cc_1_tmp_172 ():cpc_8_cc_1_tmp_162 ()));
  // bitbit_12_1_8.bdd
  outputs[12] = (bdd_op_inputs[0]?cpc_8_cc_1_tmp_172 ():(bdd_op_inputs[8]?cpc_8_cc_1_tmp_171 ():cpc_8_cc_1_tmp_161 ()));
  // bitbit_13_1_8.bdd
  outputs[13] = (bdd_op_inputs[8] && (bdd_op_inputs[24] && cpc_8_cc_1_tmp_170 ()));
  // bitbit_14_1_8.bdd
  outputs[14] = 1;
  // bitbit_15_1_8.bdd
  outputs[15] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_1_tmp_170 ():(bdd_op_inputs[24] || cpc_8_cc_1_tmp_160 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_1_tmp_170 ():cpc_8_cc_1_tmp_138 ())):cpc_8_cc_1_tmp_161 ()));
  break;

case 3:
  // bitbit_00_3_8.bdd
  outputs[0] = 0;
  // bitbit_01_3_8.bdd
  outputs[1] = 0;
  // bitbit_02_3_8.bdd
  outputs[2] = cpc_8_cc_3_tmp_181 ();
  // bitbit_03_3_8.bdd
  outputs[3] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_3_tmp_187 ():cpc_8_cc_3_tmp_188 ()):cpc_8_cc_3_tmp_190 ());
  // bitbit_04_3_8.bdd
  outputs[4] = (bdd_op_inputs[0]?cpc_8_cc_3_tmp_190 ():(bdd_op_inputs[8] && (bdd_op_inputs[16] && cpc_8_cc_3_tmp_210 ())));
  // bitbit_05_3_8.bdd
  outputs[5] = (bdd_op_inputs[0]?cpc_8_cc_3_tmp_211 ():(bdd_op_inputs[8] && cpc_8_cc_3_tmp_212 ()));
  // bitbit_06_3_8.bdd
  outputs[6] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_3_tmp_22 ():(bdd_op_inputs[24] && cpc_8_cc_3_tmp_219 ())):(bdd_op_inputs[8] && (bdd_op_inputs[16]?cpc_8_cc_3_tmp_219 ():(bdd_op_inputs[24] && cpc_8_cc_3_tmp_22 ()))));
  // bitbit_07_3_8.bdd
  outputs[7] = (bdd_op_inputs[0]?cpc_8_cc_3_tmp_28 ():(bdd_op_inputs[8]?(bdd_op_inputs[16] || cpc_8_cc_3_tmp_187 ()):cpc_8_cc_3_tmp_28 ()));
  // bitbit_08_3_8.bdd
  outputs[8] = 1;
  // bitbit_09_3_8.bdd
  outputs[9] = 1;
  // bitbit_10_3_8.bdd
  outputs[10] = cpc_8_cc_3_tmp_222 ();
  // bitbit_11_3_8.bdd
  outputs[11] = (bdd_op_inputs[0]?cpc_8_cc_3_tmp_226 ():(bdd_op_inputs[8]?cpc_8_cc_3_tmp_227 ():cpc_8_cc_3_tmp_212 ()));
  // bitbit_12_3_8.bdd
  outputs[12] = (bdd_op_inputs[0]?cpc_8_cc_3_tmp_227 ():(bdd_op_inputs[8]?cpc_8_cc_3_tmp_226 ():cpc_8_cc_3_tmp_211 ()));
  // bitbit_13_3_8.bdd
  outputs[13] = (bdd_op_inputs[8] && (bdd_op_inputs[24] && cpc_8_cc_3_tmp_225 ()));
  // bitbit_14_3_8.bdd
  outputs[14] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_3_tmp_273 ():(bdd_op_inputs[24]?cpc_8_cc_3_tmp_276 ():cpc_8_cc_3_tmp_277 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16]?cpc_8_cc_3_tmp_276 ():(bdd_op_inputs[24]?cpc_8_cc_3_tmp_273 ():cpc_8_cc_3_tmp_277 ())):cpc_8_cc_3_tmp_277 ()));
  // bitbit_15_3_8.bdd
  outputs[15] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpc_8_cc_3_tmp_225 ():(bdd_op_inputs[24] || cpc_8_cc_3_tmp_210 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpc_8_cc_3_tmp_225 ():cpc_8_cc_3_tmp_187 ())):cpc_8_cc_3_tmp_211 ()));
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

struct mem_loc_t bdd_bitbit_cpc_diag_res (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x3; ++cc_value) {
    if ((cc.val & cc.known & 0x3) != 
	(cc_value & cc.known & 0x3)) continue;
    if ((cc_value & ~0x3) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_0_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 2:
  // bitbit_00_2_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_2_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_2_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_2_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_2_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_2_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_2_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_2_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_2_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_2_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_2_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_2_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_2_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_2_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_2_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_2_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_1_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_1_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_1_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_1_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_1_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_1_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_1_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_1_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_1_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_1_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_1_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_1_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_1_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_1_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_1_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

case 3:
  // bitbit_00_3_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_3_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_3_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_3_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_3_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_3_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_3_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_3_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_3_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_3_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_3_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_3_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_3_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_3_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_3_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_3_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

struct mem_loc_t bdd_bitbit_cpc_diag_cc (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x3; ++cc_value) {
    if ((cc.val & cc.known & 0x3) != 
	(cc_value & cc.known & 0x3)) continue;
    if ((cc_value & ~0x3) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = 0;
  // bitbit_04_0_8.bdd
  outputs[4] = 0;
  // bitbit_05_0_8.bdd
  outputs[5] = 0;
  // bitbit_06_0_8.bdd
  outputs[6] = 0;
  // bitbit_07_0_8.bdd
  outputs[7] = 0;
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = 1;
  // bitbit_12_0_8.bdd
  outputs[12] = 1;
  // bitbit_13_0_8.bdd
  outputs[13] = 1;
  // bitbit_14_0_8.bdd
  outputs[14] = 1;
  // bitbit_15_0_8.bdd
  outputs[15] = 1;
  break;

case 2:
  // bitbit_00_2_8.bdd
  outputs[0] = 0;
  // bitbit_01_2_8.bdd
  outputs[1] = 0;
  // bitbit_02_2_8.bdd
  outputs[2] = 0;
  // bitbit_03_2_8.bdd
  outputs[3] = 0;
  // bitbit_04_2_8.bdd
  outputs[4] = 0;
  // bitbit_05_2_8.bdd
  outputs[5] = 0;
  // bitbit_06_2_8.bdd
  outputs[6] = 1;
  // bitbit_07_2_8.bdd
  outputs[7] = 0;
  // bitbit_08_2_8.bdd
  outputs[8] = 1;
  // bitbit_09_2_8.bdd
  outputs[9] = 1;
  // bitbit_10_2_8.bdd
  outputs[10] = 1;
  // bitbit_11_2_8.bdd
  outputs[11] = 1;
  // bitbit_12_2_8.bdd
  outputs[12] = 1;
  // bitbit_13_2_8.bdd
  outputs[13] = 1;
  // bitbit_14_2_8.bdd
  outputs[14] = 1;
  // bitbit_15_2_8.bdd
  outputs[15] = 1;
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = 0;
  // bitbit_01_1_8.bdd
  outputs[1] = 0;
  // bitbit_02_1_8.bdd
  outputs[2] = 1;
  // bitbit_03_1_8.bdd
  outputs[3] = 1;
  // bitbit_04_1_8.bdd
  outputs[4] = 0;
  // bitbit_05_1_8.bdd
  outputs[5] = 1;
  // bitbit_06_1_8.bdd
  outputs[6] = 0;
  // bitbit_07_1_8.bdd
  outputs[7] = 1;
  // bitbit_08_1_8.bdd
  outputs[8] = 1;
  // bitbit_09_1_8.bdd
  outputs[9] = 1;
  // bitbit_10_1_8.bdd
  outputs[10] = 1;
  // bitbit_11_1_8.bdd
  outputs[11] = 1;
  // bitbit_12_1_8.bdd
  outputs[12] = 1;
  // bitbit_13_1_8.bdd
  outputs[13] = 1;
  // bitbit_14_1_8.bdd
  outputs[14] = 1;
  // bitbit_15_1_8.bdd
  outputs[15] = 1;
  break;

case 3:
  // bitbit_00_3_8.bdd
  outputs[0] = 0;
  // bitbit_01_3_8.bdd
  outputs[1] = 0;
  // bitbit_02_3_8.bdd
  outputs[2] = 1;
  // bitbit_03_3_8.bdd
  outputs[3] = 1;
  // bitbit_04_3_8.bdd
  outputs[4] = 0;
  // bitbit_05_3_8.bdd
  outputs[5] = 1;
  // bitbit_06_3_8.bdd
  outputs[6] = 0;
  // bitbit_07_3_8.bdd
  outputs[7] = 1;
  // bitbit_08_3_8.bdd
  outputs[8] = 1;
  // bitbit_09_3_8.bdd
  outputs[9] = 1;
  // bitbit_10_3_8.bdd
  outputs[10] = 1;
  // bitbit_11_3_8.bdd
  outputs[11] = 1;
  // bitbit_12_3_8.bdd
  outputs[12] = 1;
  // bitbit_13_3_8.bdd
  outputs[13] = 1;
  // bitbit_14_3_8.bdd
  outputs[14] = 1;
  // bitbit_15_3_8.bdd
  outputs[15] = 1;
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_cpc (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  if (src_reg == dst_reg)  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_cpc_diag_res (get_mem (m, dst_reg), ccin);
    struct mem_loc_t cc  = bdd_bitbit_cpc_diag_cc  (get_mem (m, dst_reg), ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x3e);
  } else {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_cpc_res (get_mem (m, dst_reg), get_mem (m, src_reg), ccin);
    struct mem_loc_t cc  = bdd_bitbit_cpc_cc  (get_mem (m, dst_reg), get_mem (m, src_reg), ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x3f);
  }
}
#endif

#ifdef STACKTOOL
void classic_bitbit_cpc (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  struct decoder_info dec;
  dec.opcode = AVR_cpc;
#if (2==2)
#if 0
  dec.K = imm;
  dec.K_set = 1;  
#else
  dec.src_reg = src_reg;
  dec.src_reg_set = 1;
#endif
#endif
  dec.dst_reg = dst_reg;
  dec.dst_reg_set = 1;
  abstract_interp_insn (m, &dec);
}
#endif

