#include "stacktool.h"
#include "bdd_bitbit_cpi.h"

struct mem_loc_t bdd_bitbit_cpi_res (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = bdd_op_inputs[0];
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[1];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[2];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[3];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[4];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[5];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[6];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[7];
  // bitbit_08_0_8.bdd
  outputs[8] = bdd_op_inputs[8];
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[9];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[10];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[11];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[12];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[13];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[14];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[15];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int cpi_8_cc_0_tmp_0 (void) {
  return bdd_op_inputs[23];
}

static int cpi_8_cc_0_tmp_1 (void) {
  return (bdd_op_inputs[15] && cpi_8_cc_0_tmp_0 ());
}

static int cpi_8_cc_0_tmp_2 (void) {
  return (bdd_op_inputs[7]?0:cpi_8_cc_0_tmp_1 ());
}

static int cpi_8_cc_0_tmp_3 (void) {
  return (bdd_op_inputs[22] && cpi_8_cc_0_tmp_2 ());
}

static int cpi_8_cc_0_tmp_4 (void) {
  return (bdd_op_inputs[6]?cpi_8_cc_0_tmp_3 ():(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpi_8_cc_0_tmp_2 ()):cpi_8_cc_0_tmp_3 ()));
}

static int cpi_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[21] && cpi_8_cc_0_tmp_4 ());
}

static int cpi_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[5]?cpi_8_cc_0_tmp_5 ():(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpi_8_cc_0_tmp_4 ()):cpi_8_cc_0_tmp_5 ()));
}

static int cpi_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[20] && cpi_8_cc_0_tmp_6 ());
}

static int cpi_8_cc_0_tmp_8 (void) {
  return (bdd_op_inputs[4]?cpi_8_cc_0_tmp_7 ():(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpi_8_cc_0_tmp_6 ()):cpi_8_cc_0_tmp_7 ()));
}

static int cpi_8_cc_0_tmp_9 (void) {
  return (bdd_op_inputs[19] && cpi_8_cc_0_tmp_8 ());
}

static int cpi_8_cc_0_tmp_10 (void) {
  return (bdd_op_inputs[3]?cpi_8_cc_0_tmp_9 ():(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpi_8_cc_0_tmp_8 ()):cpi_8_cc_0_tmp_9 ()));
}

static int cpi_8_cc_0_tmp_11 (void) {
  return (bdd_op_inputs[18] && cpi_8_cc_0_tmp_10 ());
}

static int cpi_8_cc_0_tmp_12 (void) {
  return (bdd_op_inputs[2]?cpi_8_cc_0_tmp_11 ():(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpi_8_cc_0_tmp_10 ()):cpi_8_cc_0_tmp_11 ()));
}

static int cpi_8_cc_0_tmp_13 (void) {
  return (bdd_op_inputs[17] && cpi_8_cc_0_tmp_12 ());
}

static int cpi_8_cc_0_tmp_14 (void) {
  return (bdd_op_inputs[1]?cpi_8_cc_0_tmp_13 ():(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpi_8_cc_0_tmp_12 ()):cpi_8_cc_0_tmp_13 ()));
}

static int cpi_8_cc_0_tmp_15 (void) {
  return (bdd_op_inputs[24] || cpi_8_cc_0_tmp_14 ());
}

static int cpi_8_cc_0_tmp_16 (void) {
  return (bdd_op_inputs[24] && cpi_8_cc_0_tmp_14 ());
}

static int cpi_8_cc_0_tmp_17 (void) {
  return (bdd_op_inputs[16]?0:cpi_8_cc_0_tmp_16 ());
}

static int cpi_8_cc_0_tmp_18 (void) {
  return bdd_op_inputs[31];
}

static int cpi_8_cc_0_tmp_19 (void) {
  return (bdd_op_inputs[23]?0:cpi_8_cc_0_tmp_18 ());
}

static int cpi_8_cc_0_tmp_20 (void) {
  return (bdd_op_inputs[7] || cpi_8_cc_0_tmp_19 ());
}

static int cpi_8_cc_0_tmp_21 (void) {
  return (bdd_op_inputs[30] || cpi_8_cc_0_tmp_20 ());
}

static int cpi_8_cc_0_tmp_22 (void) {
  return (bdd_op_inputs[30] && cpi_8_cc_0_tmp_20 ());
}

static int cpi_8_cc_0_tmp_23 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpi_8_cc_0_tmp_20 ():cpi_8_cc_0_tmp_21 ()):(bdd_op_inputs[22]?0:cpi_8_cc_0_tmp_22 ()));
}

static int cpi_8_cc_0_tmp_24 (void) {
  return (bdd_op_inputs[29] || cpi_8_cc_0_tmp_23 ());
}

static int cpi_8_cc_0_tmp_25 (void) {
  return (bdd_op_inputs[29] && cpi_8_cc_0_tmp_23 ());
}

static int cpi_8_cc_0_tmp_26 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpi_8_cc_0_tmp_23 ():cpi_8_cc_0_tmp_24 ()):(bdd_op_inputs[21]?0:cpi_8_cc_0_tmp_25 ()));
}

static int cpi_8_cc_0_tmp_27 (void) {
  return (bdd_op_inputs[28] || cpi_8_cc_0_tmp_26 ());
}

static int cpi_8_cc_0_tmp_28 (void) {
  return (bdd_op_inputs[28] && cpi_8_cc_0_tmp_26 ());
}

static int cpi_8_cc_0_tmp_29 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpi_8_cc_0_tmp_26 ():cpi_8_cc_0_tmp_27 ()):(bdd_op_inputs[20]?0:cpi_8_cc_0_tmp_28 ()));
}

static int cpi_8_cc_0_tmp_30 (void) {
  return (bdd_op_inputs[27] || cpi_8_cc_0_tmp_29 ());
}

static int cpi_8_cc_0_tmp_31 (void) {
  return (bdd_op_inputs[27] && cpi_8_cc_0_tmp_29 ());
}

static int cpi_8_cc_0_tmp_32 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpi_8_cc_0_tmp_29 ():cpi_8_cc_0_tmp_30 ()):(bdd_op_inputs[19]?0:cpi_8_cc_0_tmp_31 ()));
}

static int cpi_8_cc_0_tmp_33 (void) {
  return (bdd_op_inputs[26] || cpi_8_cc_0_tmp_32 ());
}

static int cpi_8_cc_0_tmp_34 (void) {
  return (bdd_op_inputs[26] && cpi_8_cc_0_tmp_32 ());
}

static int cpi_8_cc_0_tmp_35 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpi_8_cc_0_tmp_32 ():cpi_8_cc_0_tmp_33 ()):(bdd_op_inputs[18]?0:cpi_8_cc_0_tmp_34 ()));
}

static int cpi_8_cc_0_tmp_36 (void) {
  return (bdd_op_inputs[25] || cpi_8_cc_0_tmp_35 ());
}

static int cpi_8_cc_0_tmp_37 (void) {
  return (bdd_op_inputs[25] && cpi_8_cc_0_tmp_35 ());
}

static int cpi_8_cc_0_tmp_38 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpi_8_cc_0_tmp_35 ():cpi_8_cc_0_tmp_36 ()):(bdd_op_inputs[17]?0:cpi_8_cc_0_tmp_37 ()));
}

static int cpi_8_cc_0_tmp_39 (void) {
  return (bdd_op_inputs[16]?cpi_8_cc_0_tmp_14 ():(bdd_op_inputs[24] && cpi_8_cc_0_tmp_38 ()));
}

static int cpi_8_cc_0_tmp_40 (void) {
  return (bdd_op_inputs[16]?cpi_8_cc_0_tmp_38 ():cpi_8_cc_0_tmp_16 ());
}

static int cpi_8_cc_0_tmp_41 (void) {
  return (bdd_op_inputs[7]?cpi_8_cc_0_tmp_0 ():(bdd_op_inputs[15] && cpi_8_cc_0_tmp_19 ()));
}

static int cpi_8_cc_0_tmp_42 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22] && cpi_8_cc_0_tmp_41 ()):(bdd_op_inputs[14] && (bdd_op_inputs[22]?0:(bdd_op_inputs[30] && cpi_8_cc_0_tmp_41 ()))));
}

static int cpi_8_cc_0_tmp_43 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21] && cpi_8_cc_0_tmp_42 ()):(bdd_op_inputs[13] && (bdd_op_inputs[21]?0:(bdd_op_inputs[29] && cpi_8_cc_0_tmp_42 ()))));
}

static int cpi_8_cc_0_tmp_44 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20] && cpi_8_cc_0_tmp_43 ()):(bdd_op_inputs[12] && (bdd_op_inputs[20]?0:(bdd_op_inputs[28] && cpi_8_cc_0_tmp_43 ()))));
}

static int cpi_8_cc_0_tmp_45 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19] && cpi_8_cc_0_tmp_44 ()):(bdd_op_inputs[11] && (bdd_op_inputs[19]?0:(bdd_op_inputs[27] && cpi_8_cc_0_tmp_44 ()))));
}

static int cpi_8_cc_0_tmp_46 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18] && cpi_8_cc_0_tmp_45 ()):(bdd_op_inputs[10] && (bdd_op_inputs[18]?0:(bdd_op_inputs[26] && cpi_8_cc_0_tmp_45 ()))));
}

static int cpi_8_cc_0_tmp_47 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17] && cpi_8_cc_0_tmp_46 ()):(bdd_op_inputs[9] && (bdd_op_inputs[17]?0:(bdd_op_inputs[25] && cpi_8_cc_0_tmp_46 ()))));
}

static int cpi_8_cc_0_tmp_48 (void) {
  return (bdd_op_inputs[16] && cpi_8_cc_0_tmp_14 ());
}

static int cpi_8_cc_0_tmp_49 (void) {
  return (bdd_op_inputs[7] || (bdd_op_inputs[15]?cpi_8_cc_0_tmp_18 ():cpi_8_cc_0_tmp_19 ()));
}

static int cpi_8_cc_0_tmp_50 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpi_8_cc_0_tmp_49 ():cpi_8_cc_0_tmp_21 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpi_8_cc_0_tmp_49 ():cpi_8_cc_0_tmp_2 ())):(bdd_op_inputs[22]?cpi_8_cc_0_tmp_2 ():cpi_8_cc_0_tmp_22 ())));
}

static int cpi_8_cc_0_tmp_51 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpi_8_cc_0_tmp_50 ():cpi_8_cc_0_tmp_24 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpi_8_cc_0_tmp_50 ():cpi_8_cc_0_tmp_4 ())):(bdd_op_inputs[21]?cpi_8_cc_0_tmp_4 ():cpi_8_cc_0_tmp_25 ())));
}

static int cpi_8_cc_0_tmp_52 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpi_8_cc_0_tmp_51 ():cpi_8_cc_0_tmp_27 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpi_8_cc_0_tmp_51 ():cpi_8_cc_0_tmp_6 ())):(bdd_op_inputs[20]?cpi_8_cc_0_tmp_6 ():cpi_8_cc_0_tmp_28 ())));
}

static int cpi_8_cc_0_tmp_53 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpi_8_cc_0_tmp_52 ():cpi_8_cc_0_tmp_30 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpi_8_cc_0_tmp_52 ():cpi_8_cc_0_tmp_8 ())):(bdd_op_inputs[19]?cpi_8_cc_0_tmp_8 ():cpi_8_cc_0_tmp_31 ())));
}

static int cpi_8_cc_0_tmp_54 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpi_8_cc_0_tmp_53 ():cpi_8_cc_0_tmp_33 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpi_8_cc_0_tmp_53 ():cpi_8_cc_0_tmp_10 ())):(bdd_op_inputs[18]?cpi_8_cc_0_tmp_10 ():cpi_8_cc_0_tmp_34 ())));
}

static int cpi_8_cc_0_tmp_55 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpi_8_cc_0_tmp_54 ():cpi_8_cc_0_tmp_36 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpi_8_cc_0_tmp_54 ():cpi_8_cc_0_tmp_12 ())):(bdd_op_inputs[17]?cpi_8_cc_0_tmp_12 ():cpi_8_cc_0_tmp_37 ())));
}

static int cpi_8_cc_0_tmp_56 (void) {
  return (bdd_op_inputs[16]?cpi_8_cc_0_tmp_55 ():cpi_8_cc_0_tmp_15 ());
}

static int cpi_8_cc_0_tmp_57 (void) {
  return (bdd_op_inputs[16] || (bdd_op_inputs[24]?cpi_8_cc_0_tmp_55 ():cpi_8_cc_0_tmp_38 ()));
}

static int cpi_8_cc_0_tmp_58 (void) {
  return (bdd_op_inputs[15] && cpi_8_cc_0_tmp_18 ());
}

static int cpi_8_cc_0_tmp_59 (void) {
  return (bdd_op_inputs[7]?cpi_8_cc_0_tmp_19 ():cpi_8_cc_0_tmp_1 ());
}

static int cpi_8_cc_0_tmp_60 (void) {
  return (bdd_op_inputs[30] || cpi_8_cc_0_tmp_59 ());
}

static int cpi_8_cc_0_tmp_61 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpi_8_cc_0_tmp_58 ():cpi_8_cc_0_tmp_60 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || (bdd_op_inputs[30]?cpi_8_cc_0_tmp_58 ():cpi_8_cc_0_tmp_59 ())):cpi_8_cc_0_tmp_59 ()));
}

static int cpi_8_cc_0_tmp_62 (void) {
  return (bdd_op_inputs[6]?(bdd_op_inputs[22]?cpi_8_cc_0_tmp_59 ():cpi_8_cc_0_tmp_60 ()):(bdd_op_inputs[14]?(bdd_op_inputs[22] || cpi_8_cc_0_tmp_59 ()):cpi_8_cc_0_tmp_59 ()));
}

static int cpi_8_cc_0_tmp_63 (void) {
  return (bdd_op_inputs[29] || cpi_8_cc_0_tmp_62 ());
}

static int cpi_8_cc_0_tmp_64 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpi_8_cc_0_tmp_61 ():cpi_8_cc_0_tmp_63 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || (bdd_op_inputs[29]?cpi_8_cc_0_tmp_61 ():cpi_8_cc_0_tmp_62 ())):cpi_8_cc_0_tmp_62 ()));
}

static int cpi_8_cc_0_tmp_65 (void) {
  return (bdd_op_inputs[5]?(bdd_op_inputs[21]?cpi_8_cc_0_tmp_62 ():cpi_8_cc_0_tmp_63 ()):(bdd_op_inputs[13]?(bdd_op_inputs[21] || cpi_8_cc_0_tmp_62 ()):cpi_8_cc_0_tmp_62 ()));
}

static int cpi_8_cc_0_tmp_66 (void) {
  return (bdd_op_inputs[28] || cpi_8_cc_0_tmp_65 ());
}

static int cpi_8_cc_0_tmp_67 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpi_8_cc_0_tmp_64 ():cpi_8_cc_0_tmp_66 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || (bdd_op_inputs[28]?cpi_8_cc_0_tmp_64 ():cpi_8_cc_0_tmp_65 ())):cpi_8_cc_0_tmp_65 ()));
}

static int cpi_8_cc_0_tmp_68 (void) {
  return (bdd_op_inputs[4]?(bdd_op_inputs[20]?cpi_8_cc_0_tmp_65 ():cpi_8_cc_0_tmp_66 ()):(bdd_op_inputs[12]?(bdd_op_inputs[20] || cpi_8_cc_0_tmp_65 ()):cpi_8_cc_0_tmp_65 ()));
}

static int cpi_8_cc_0_tmp_69 (void) {
  return (bdd_op_inputs[27] || cpi_8_cc_0_tmp_68 ());
}

static int cpi_8_cc_0_tmp_70 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpi_8_cc_0_tmp_67 ():cpi_8_cc_0_tmp_69 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || (bdd_op_inputs[27]?cpi_8_cc_0_tmp_67 ():cpi_8_cc_0_tmp_68 ())):cpi_8_cc_0_tmp_68 ()));
}

static int cpi_8_cc_0_tmp_71 (void) {
  return (bdd_op_inputs[3]?(bdd_op_inputs[19]?cpi_8_cc_0_tmp_68 ():cpi_8_cc_0_tmp_69 ()):(bdd_op_inputs[11]?(bdd_op_inputs[19] || cpi_8_cc_0_tmp_68 ()):cpi_8_cc_0_tmp_68 ()));
}

static int cpi_8_cc_0_tmp_72 (void) {
  return (bdd_op_inputs[26] || cpi_8_cc_0_tmp_71 ());
}

static int cpi_8_cc_0_tmp_73 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpi_8_cc_0_tmp_70 ():cpi_8_cc_0_tmp_72 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || (bdd_op_inputs[26]?cpi_8_cc_0_tmp_70 ():cpi_8_cc_0_tmp_71 ())):cpi_8_cc_0_tmp_71 ()));
}

static int cpi_8_cc_0_tmp_74 (void) {
  return (bdd_op_inputs[2]?(bdd_op_inputs[18]?cpi_8_cc_0_tmp_71 ():cpi_8_cc_0_tmp_72 ()):(bdd_op_inputs[10]?(bdd_op_inputs[18] || cpi_8_cc_0_tmp_71 ()):cpi_8_cc_0_tmp_71 ()));
}

static int cpi_8_cc_0_tmp_75 (void) {
  return (bdd_op_inputs[25] || cpi_8_cc_0_tmp_74 ());
}

static int cpi_8_cc_0_tmp_76 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpi_8_cc_0_tmp_73 ():cpi_8_cc_0_tmp_75 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || (bdd_op_inputs[25]?cpi_8_cc_0_tmp_73 ():cpi_8_cc_0_tmp_74 ())):cpi_8_cc_0_tmp_74 ()));
}

static int cpi_8_cc_0_tmp_77 (void) {
  return (bdd_op_inputs[1]?(bdd_op_inputs[17]?cpi_8_cc_0_tmp_74 ():cpi_8_cc_0_tmp_75 ()):(bdd_op_inputs[9]?(bdd_op_inputs[17] || cpi_8_cc_0_tmp_74 ()):cpi_8_cc_0_tmp_74 ()));
}

struct mem_loc_t bdd_bitbit_cpi_cc (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = cpi_8_cc_0_tmp_8 ();
  // bitbit_03_0_8.bdd
  outputs[3] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpi_8_cc_0_tmp_14 ():cpi_8_cc_0_tmp_15 ()):cpi_8_cc_0_tmp_17 ());
  // bitbit_04_0_8.bdd
  outputs[4] = (bdd_op_inputs[0]?cpi_8_cc_0_tmp_17 ():(bdd_op_inputs[8] && (bdd_op_inputs[16] && cpi_8_cc_0_tmp_38 ())));
  // bitbit_05_0_8.bdd
  outputs[5] = (bdd_op_inputs[0]?cpi_8_cc_0_tmp_39 ():(bdd_op_inputs[8] && cpi_8_cc_0_tmp_40 ()));
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[0]?(bdd_op_inputs[16] && cpi_8_cc_0_tmp_47 ()):(bdd_op_inputs[8] && (bdd_op_inputs[16]?0:(bdd_op_inputs[24] && cpi_8_cc_0_tmp_47 ()))));
  // bitbit_07_0_8.bdd
  outputs[7] = (bdd_op_inputs[0]?cpi_8_cc_0_tmp_48 ():(bdd_op_inputs[8]?(bdd_op_inputs[16] || cpi_8_cc_0_tmp_14 ()):cpi_8_cc_0_tmp_48 ()));
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = cpi_8_cc_0_tmp_52 ();
  // bitbit_11_0_8.bdd
  outputs[11] = (bdd_op_inputs[0]?cpi_8_cc_0_tmp_56 ():(bdd_op_inputs[8]?cpi_8_cc_0_tmp_57 ():cpi_8_cc_0_tmp_40 ()));
  // bitbit_12_0_8.bdd
  outputs[12] = (bdd_op_inputs[0]?cpi_8_cc_0_tmp_57 ():(bdd_op_inputs[8]?cpi_8_cc_0_tmp_56 ():cpi_8_cc_0_tmp_39 ()));
  // bitbit_13_0_8.bdd
  outputs[13] = (bdd_op_inputs[8] && (bdd_op_inputs[24] && cpi_8_cc_0_tmp_55 ()));
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpi_8_cc_0_tmp_76 ():(bdd_op_inputs[24] || cpi_8_cc_0_tmp_77 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpi_8_cc_0_tmp_76 ():cpi_8_cc_0_tmp_77 ())):cpi_8_cc_0_tmp_77 ()));
  // bitbit_15_0_8.bdd
  outputs[15] = (bdd_op_inputs[0]?(bdd_op_inputs[16]?cpi_8_cc_0_tmp_55 ():(bdd_op_inputs[24] || cpi_8_cc_0_tmp_38 ())):(bdd_op_inputs[8]?(bdd_op_inputs[16] || (bdd_op_inputs[24]?cpi_8_cc_0_tmp_55 ():cpi_8_cc_0_tmp_14 ())):cpi_8_cc_0_tmp_39 ()));
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_cpi (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 1
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_cpi_res (get_mem (m, dst_reg), imm, ccin);
    struct mem_loc_t cc  = bdd_bitbit_cpi_cc  (get_mem (m, dst_reg), imm, ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x3f);
  }
}
#endif

#ifdef STACKTOOL
void classic_bitbit_cpi (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 1
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  struct decoder_info dec;
  dec.opcode = AVR_cpi;
#if (2==2)
#if 1
  dec.K = imm;
  dec.K_set = 1;  
#else
  dec.src_reg = src_reg;
  dec.src_reg_set = 1;
#endif
#endif
  dec.dst_reg = dst_reg;
  dec.dst_reg_set = 1;
  abstract_interp_insn (m, &dec);
}
#endif

