#include "stacktool.h"
#include "bdd_bitbit_ror.h"

struct mem_loc_t bdd_bitbit_ror_res (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x1; ++cc_value) {
    if ((cc.val & cc.known & 0x1) != 
	(cc_value & cc.known & 0x1)) continue;
    if ((cc_value & ~0x1) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[0];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[1];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[2];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[3];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[4];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[5];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[6];
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[8];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[9];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[10];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[11];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[12];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[13];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[14];
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = 1;
  // bitbit_01_1_8.bdd
  outputs[1] = bdd_op_inputs[0];
  // bitbit_02_1_8.bdd
  outputs[2] = bdd_op_inputs[1];
  // bitbit_03_1_8.bdd
  outputs[3] = bdd_op_inputs[2];
  // bitbit_04_1_8.bdd
  outputs[4] = bdd_op_inputs[3];
  // bitbit_05_1_8.bdd
  outputs[5] = bdd_op_inputs[4];
  // bitbit_06_1_8.bdd
  outputs[6] = bdd_op_inputs[5];
  // bitbit_07_1_8.bdd
  outputs[7] = bdd_op_inputs[6];
  // bitbit_08_1_8.bdd
  outputs[8] = 1;
  // bitbit_09_1_8.bdd
  outputs[9] = bdd_op_inputs[8];
  // bitbit_10_1_8.bdd
  outputs[10] = bdd_op_inputs[9];
  // bitbit_11_1_8.bdd
  outputs[11] = bdd_op_inputs[10];
  // bitbit_12_1_8.bdd
  outputs[12] = bdd_op_inputs[11];
  // bitbit_13_1_8.bdd
  outputs[13] = bdd_op_inputs[12];
  // bitbit_14_1_8.bdd
  outputs[14] = bdd_op_inputs[13];
  // bitbit_15_1_8.bdd
  outputs[15] = bdd_op_inputs[14];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

static int ror_8_cc_0_tmp_0 (void) {
  return bdd_op_inputs[7];
}

static int ror_8_cc_0_tmp_1 (void) {
  return bdd_op_inputs[14];
}

static int ror_8_cc_0_tmp_2 (void) {
  return bdd_op_inputs[15];
}

static int ror_8_cc_0_tmp_3 (void) {
  return bdd_op_inputs[6];
}

static int ror_8_cc_0_tmp_4 (void) {
  return (bdd_op_inputs[5] || ror_8_cc_0_tmp_3 ());
}

static int ror_8_cc_0_tmp_5 (void) {
  return (bdd_op_inputs[4] || ror_8_cc_0_tmp_4 ());
}

static int ror_8_cc_0_tmp_6 (void) {
  return (bdd_op_inputs[3] || ror_8_cc_0_tmp_5 ());
}

static int ror_8_cc_0_tmp_7 (void) {
  return (bdd_op_inputs[2] || ror_8_cc_0_tmp_6 ());
}

static int ror_8_cc_1_tmp_0 (void) {
  return bdd_op_inputs[7];
}

static int ror_8_cc_1_tmp_2 (void) {
  return bdd_op_inputs[15];
}

struct mem_loc_t bdd_bitbit_ror_cc (struct mem_loc_t in1, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x1; ++cc_value) {
    if ((cc.val & cc.known & 0x1) != 
	(cc_value & cc.known & 0x1)) continue;
    if ((cc_value & ~0x1) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = ror_8_cc_0_tmp_0 ();
  // bitbit_04_0_8.bdd
  outputs[4] = ror_8_cc_0_tmp_0 ();
  // bitbit_05_0_8.bdd
  outputs[5] = 0;
  // bitbit_06_0_8.bdd
  outputs[6] = (bdd_op_inputs[0]?0:(bdd_op_inputs[8] && (bdd_op_inputs[1]?0:(bdd_op_inputs[9] && (bdd_op_inputs[2]?0:(bdd_op_inputs[10] && (bdd_op_inputs[3]?0:(bdd_op_inputs[11] && (bdd_op_inputs[4]?0:(bdd_op_inputs[12] && (bdd_op_inputs[5]?0:(bdd_op_inputs[13] && (bdd_op_inputs[6]?0:ror_8_cc_0_tmp_1 ())))))))))))));
  // bitbit_07_0_8.bdd
  outputs[7] = ror_8_cc_0_tmp_0 ();
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = ror_8_cc_0_tmp_2 ();
  // bitbit_12_0_8.bdd
  outputs[12] = ror_8_cc_0_tmp_2 ();
  // bitbit_13_0_8.bdd
  outputs[13] = 1;
  // bitbit_14_0_8.bdd
  outputs[14] = (bdd_op_inputs[0] || (bdd_op_inputs[8]?(bdd_op_inputs[1] || (bdd_op_inputs[9]?(bdd_op_inputs[2] || (bdd_op_inputs[10]?(bdd_op_inputs[3] || (bdd_op_inputs[11]?(bdd_op_inputs[4] || (bdd_op_inputs[12]?(bdd_op_inputs[5] || (bdd_op_inputs[13]?ror_8_cc_0_tmp_1 ():ror_8_cc_0_tmp_3 ())):ror_8_cc_0_tmp_4 ())):ror_8_cc_0_tmp_5 ())):ror_8_cc_0_tmp_6 ())):ror_8_cc_0_tmp_7 ())):(bdd_op_inputs[1] || ror_8_cc_0_tmp_7 ())));
  // bitbit_15_0_8.bdd
  outputs[15] = ror_8_cc_0_tmp_2 ();
  break;

case 1:
  // bitbit_00_1_8.bdd
  outputs[0] = 0;
  // bitbit_01_1_8.bdd
  outputs[1] = 0;
  // bitbit_02_1_8.bdd
  outputs[2] = 0;
  // bitbit_03_1_8.bdd
  outputs[3] = ror_8_cc_1_tmp_0 ();
  // bitbit_04_1_8.bdd
  outputs[4] = (bdd_op_inputs[7]?0:ror_8_cc_1_tmp_2 ());
  // bitbit_05_1_8.bdd
  outputs[5] = 1;
  // bitbit_06_1_8.bdd
  outputs[6] = 0;
  // bitbit_07_1_8.bdd
  outputs[7] = ror_8_cc_1_tmp_0 ();
  // bitbit_08_1_8.bdd
  outputs[8] = 1;
  // bitbit_09_1_8.bdd
  outputs[9] = 1;
  // bitbit_10_1_8.bdd
  outputs[10] = 1;
  // bitbit_11_1_8.bdd
  outputs[11] = ror_8_cc_1_tmp_2 ();
  // bitbit_12_1_8.bdd
  outputs[12] = ror_8_cc_1_tmp_2 ();
  // bitbit_13_1_8.bdd
  outputs[13] = 1;
  // bitbit_14_1_8.bdd
  outputs[14] = 1;
  // bitbit_15_1_8.bdd
  outputs[15] = ror_8_cc_1_tmp_2 ();
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_ror (struct memory *m
	       ,int dst_reg 
#if (1==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_ror_res (get_mem (m, dst_reg), ccin);
    struct mem_loc_t cc  = bdd_bitbit_ror_cc  (get_mem (m, dst_reg), ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x1f);
  }
}
#endif

#ifdef STACKTOOL
void classic_bitbit_ror (struct memory *m
	       ,int dst_reg 
#if (1==2)
#if 0
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  struct decoder_info dec;
  dec.opcode = AVR_ror;
#if (1==2)
#if 0
  dec.K = imm;
  dec.K_set = 1;  
#else
  dec.src_reg = src_reg;
  dec.src_reg_set = 1;
#endif
#endif
  dec.dst_reg = dst_reg;
  dec.dst_reg_set = 1;
  abstract_interp_insn (m, &dec);
}
#endif

