#include "stacktool.h"

static const int NOT_AN_LDI = -1;

extern set<code_addr_t,MAX_TASKS> tos_tasks;

int get_ldi_register (unsigned short insn, int *immed) {
    int reg;
    if ((insn & 0xf000) == 0xe000){
	*immed = ((insn & 0x0f0f) >> 4) + (insn & 0x000f);
	reg=((insn & 0x00f0)>>4)+16;
	return reg;
    } else {
	return NOT_AN_LDI;
    }
}

bool check_inlined_task_posts(void){
    int reg1;
    int reg2;
    int rAval;
    int rBval;
    code_addr_t i;
    code_addr_t addr;
    char * symbol;
    bool known;
    bool success;

    success=true;
    i=0;
    while ((unsigned int)i<code_size) {
	if (all_code[i] == NULL) { 
	    i+=2;
	    continue;
	}
	reg1=get_ldi_register (get_insn_short (i), &rAval);
	reg2=get_ldi_register (get_insn_short (i+2), &rBval);
	if((reg1==NOT_AN_LDI)||
	   (reg2==NOT_AN_LDI)||
	   (abs(reg1-reg2)!=1)){
	    i=nextPC(i);
	    continue;
	}
	addr=(((rBval<<8)+rAval)*2);
	symbol=lookup_text_symbol (addr);

	if((symbol!=NULL)&&
	    (addr!=0)){ //vector jump table?
	    known=false;
	    for(set<code_addr_t,MAX_TASKS>::iterator iter=tos_tasks.begin();
		iter!=tos_tasks.end();
		++iter){
		if (*iter==addr) {
		    known =true;
		    break;
		}		    
	    }
	    if(!known){
		success=false;
		printf("ERROR (should be OOPS): icall from %x to unknown task at address %x, named %s.\n",
		       i, addr, symbol);
		printf("  To fix, add \"ICall %s\" line to .cnt file.\n", 
		       symbol);
	    }
	}
	i = nextPC(i);
    }
    if(success)
	return true;
    return false;
}
