////////////////////////////////////////////////////////////////
// Abstract Values
//
// We do all intermediate calculations with 32-bit values 
// and then extract the bits we need at the end.
////////////////////////////////////////////////////////////////

// Treat this as an abstract type
typedef struct {
  int known;  // bitmask
  int val;    // value
} val;

void rtl_copy( val *dst, val *src );
void rtl_merge( val *dst, val *src1, val *src2 );
void rtl_bottom( val *dst );
void rtl_set( val *dst, int known, int v );
int  rtl_minVal( val *x );
int  rtl_maxVal( val *x );
void rtl_const( val *dst, int v);

void rtl_zx(val *dst, val *src, int n);
void rtl_sx(val *dst, val *src, int n);
void rtl_extract_bits(val *dst, val *src, int s, int n);
void rtl_get_bit(val *dst, val *src, int b);
void rtl_put_bit(val *dst, val *src1, int b, val *src2);
int  rtl_val8( val *x );

void rtl_neg(val *dst, val *src);
void rtl_add(val *dst, val *src1, val *src2);
void rtl_sub(val *dst, val *src1, val *src2);

void rtl_mod(val *dst, val *src1, val *src2);
void rtl_div(val *dst, val *src1, val *src2);
void rtl_mul(val *dst, val *src1, val *src2);
void rtl_mulu(val *dst, val *src1, val *src2);

void rtl_com(val *dst, val *src);
void rtl_and(val *dst, val *src1, val *src2);
void rtl_or(val *dst, val *src1, val *src2);
void rtl_xor(val *dst, val *src1, val *src2);
void rtl_shra(val *dst, int n, val *src1, val *src2);
void rtl_shrl(val *dst, int n, val *src1, val *src2);
void rtl_rotr(val *dst, val *src1, val *src2);
void rtl_rolc(val *dst, val *src1, val *src2);

void rtl_eq(val *dst, int n, val *src1, val *src2);
void rtl_lt(val *dst, int n, val *src1, val *src2);
void rtl_le(val *dst, int n, val *src1, val *src2);
void rtl_gt(val *dst, int n, val *src1, val *src2);
void rtl_ge(val *dst, int n, val *src1, val *src2);

void rtl_cond(val *dst, val *cond, val *src1, val *src2);

////////////////////////////////////////////////////////////////
// End
////////////////////////////////////////////////////////////////
